/******************************************************************************/
/* Sistemas Integrados TECNISA                                                */
/*                                                                            */
/* Compras e Suprimentos                                                      */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/* Nome: EFETIVAR_AF                                                          */
/*                                                                            */
/* Criao:                                                                   */
/*    27/08/2000 - Alexis Tolentino                                           */
/*                                                                            */
/* Manutenes:                                                               */
/*   /  /   -                                                                 */
/*                                                                            */
/******************************************************************************/

/******************************************************************************/
/* @C:\WIN_V2\SQL\End_Conv\ORACLE\8510_SUPSTP_EFETIVAR_AF                     */
/* @H:\SISTEMAS\DBA\SQL\ORACLE\8510_SUPSTP_EFETIVAR_AF                        */
/******************************************************************************/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE
            O.NAME = 'EFETIVAR_AF' AND
            TYPE = 'P'                      AND
            U.UID = O.UID                   AND
            U.NAME = USER)

   DROP PROCEDURE EFETIVAR_AF;
GO

CREATE PROCEDURE EFETIVAR_AF
                     (@P_CDOPERADOR VARCHAR(12),
                      @P_DTAUTOFORN DATETIME,
                      @P_CDCENTCMP  VARCHAR(4),
                      @P_NRSEQAPUR  VARCHAR(10),
                      @P_CDFILLANC  VARCHAR(4))
AS
   DECLARE @V_NRITEMAF        NUMERIC;
   DECLARE @V_CODIGO          VARCHAR(20);
   DECLARE @V_CODIGO_AUX      VARCHAR(20);
   DECLARE @V_CONT            INT;
   DECLARE @V_OBSSOL          VARCHAR(2000);
   DECLARE @V_CDINSCESTA      VARCHAR(16);
   DECLARE @V_DTPROGENTAF     DATETIME;
   DECLARE @V_VRPRODUTO       DOUBLE PRECISION;
   DECLARE @V_VRDESCONTO      DOUBLE PRECISION;
   DECLARE @V_VRIMPOSTO       DOUBLE PRECISION;
   DECLARE @V_VRDESCITMAF     NUMERIC(15,5);
   DECLARE @V_NRLOTEESTQ      VARCHAR(20);
   DECLARE @V_NRSUBLOTE       VARCHAR(4);
   DECLARE @V_CDPRODPROD      VARCHAR(10);
   DECLARE @V_NMPRODPROD      VARCHAR(50);
   DECLARE @V_DIAPGTO         VARCHAR(3);
   DECLARE @V_DSPGTO          VARCHAR(1000);
   DECLARE @V_VRPGTO          VARCHAR(20);
   DECLARE @V_DSANTERIOR      VARCHAR(2000);
   DECLARE @V_DSANTERIOR_AUX  VARCHAR(2000);
   DECLARE @V_DSATUAL         VARCHAR(2000);
   DECLARE @V_ANTCODIGO       VARCHAR(10);
   DECLARE @V_ANTCDFILDEST    VARCHAR(4);
   DECLARE @V_ANTCDFILLANC    VARCHAR(4);
   DECLARE @V_ANTCDFORNECED   VARCHAR(21);
   DECLARE @V_ANTIDTPFORPGTAF VARCHAR(1);
   DECLARE @V_ANTCDTIPCOB     VARCHAR(2);

   DECLARE @V_ANTIDTIPOEMITAF VARCHAR(1);
   DECLARE @V_ANTCDEMPRESA    VARCHAR(2);
   DECLARE @V_ANTIDTIPOFRETAF VARCHAR(1);
   DECLARE @V_ANTCDFORMPGTO   VARCHAR(2);
   DECLARE @V_ANTNRPARCPGTOAF VARCHAR(3);
   DECLARE @V_ANTNRDIAPGFIXAF VARCHAR(3);
   DECLARE @V_ANTIDUTDIAPGTAF VARCHAR(1);
   DECLARE @V_ANTDSPZOPGTCONC VARCHAR(1000);
   DECLARE @V_ANTCONC_KEY     VARCHAR(1000);
   DECLARE @V_CDPERIENTR      VARCHAR(2);
   DECLARE @V_IDTIPODIA       VARCHAR(1);
   DECLARE @V_DIENTREGA       VARCHAR(3);
   DECLARE @V_NOVOCODIGO      VARCHAR(20);
   DECLARE @V_REGANTERIOR     VARCHAR(25);
   DECLARE @V_ITEMAUTF_ANTERIOR VARCHAR(255);
   DECLARE @V_AFANTERIOR      VARCHAR(18);
   DECLARE @V_SUMPERCPZO      DOUBLE PRECISION;
   DECLARE @V_COUNT_AUX       NUMERIC;
   DECLARE @V_VRPRECUNIITM    DOUBLE PRECISION;
   DECLARE @V_IDUTQTDEVOLU    VARCHAR(1);
   DECLARE @V_IDCOMPRA        VARCHAR(1);
   DECLARE @V_QTVOLUITEMSO    DOUBLE PRECISION;

   DECLARE @V_NRSOLCOMP     VARCHAR(200);
   DECLARE @V_QTSOLIPROD    DOUBLE PRECISION;
   DECLARE @V_DTAUX         DATETIME;
   DECLARE @V_VRFATOCONV    DOUBLE PRECISION;
   DECLARE @V_DTENTRITMSOL  DATETIME;
   DECLARE @V_ANTQTSOLIPROD DOUBLE PRECISION;

   DECLARE @V_AUTOFORN_DTENTRAPUT   DATETIME;
   DECLARE @V_AUTOFORN_CDMARCA      VARCHAR(5);
   DECLARE @V_AUTOFORN_CDSEGMARCA   VARCHAR(5);
   DECLARE @V_AUTOFORN_CDFILDEST    VARCHAR(4);
   DECLARE @V_AUTOFORN_CDFILLANC    VARCHAR(4);
   DECLARE @V_AUTOFORN_CDFORNECED   VARCHAR(21);
   DECLARE @V_AUTOFORN_IDTPFORPGTAP VARCHAR(1);
   DECLARE @V_AUTOFORN_CDTIPCOB     VARCHAR(2);
   DECLARE @V_AUTOFORN_DTPROGENTAF  DATETIME;
   DECLARE @V_AUTOFORN_QTPROGENTAF  DOUBLE PRECISION;
   DECLARE @V_AUTOFORN_VRPREUNIAF   DOUBLE PRECISION;
   DECLARE @V_AUTOFORN_VRPERDESAF   DOUBLE PRECISION;
   DECLARE @V_AUTOFORN_CDPRODUTO    VARCHAR(10);
   DECLARE @V_AUTOFORN_IDTIPOEMITAP VARCHAR(1);
   DECLARE @V_AUTOFORN_CDEMPRESA    VARCHAR(2);
   DECLARE @V_AUTOFORN_IDTIPOFRETAP VARCHAR(1);
   DECLARE @V_AUTOFORN_CDFORMPGTO   VARCHAR(2);
   DECLARE @V_AUTOFORN_NRPARCPGTOAP NUMERIC;
   DECLARE @V_AUTOFORN_NRDIAPGFIXAF NUMERIC;
   DECLARE @V_AUTOFORN_IDUTDIAPGTAF VARCHAR(1);
   DECLARE @V_AUTOFORN_DSPZOPGTCOAP VARCHAR(1000);
   DECLARE @V_AUTOFORN_CONC_KEY     VARCHAR(150);
   DECLARE @V_AUTOFORN_IDPRODWEB    VARCHAR(1);
   DECLARE @V_AUTOFORN_IDAFOPERLOG  VARCHAR(1);
   DECLARE @V_AUTOFORN_CDCENTITMAP  VARCHAR(4);
   DECLARE @V_AUTOFORN_CDREGITMAP   VARCHAR(3);
   DECLARE @V_AUTOFORN_IDMOTIVPRESC VARCHAR(10);
   DECLARE @V_AUTOFORN_IDFUNCAOFILI VARCHAR(1);
   DECLARE @V_AUTOFORN_CDARVPROD    VARCHAR(20);
   DECLARE @V_AUTOFORN_IDUTQTDISPFORN VARCHAR(1);

   DECLARE @V_ITEMSOLI_CDFILSOLI    VARCHAR(4);
   DECLARE @V_ITEMSOLI_CDFILLAN     VARCHAR(4);
   DECLARE @V_ITEMSOLI_NRSOLICMP    VARCHAR(10);
   DECLARE @V_ITEMSOLI_CDPRODUTO    VARCHAR(10);
   DECLARE @V_ITEMSOLI_DTPROGENTR   DATETIME;
   DECLARE @V_ITEMSOLI_QTSOLIPROD   DOUBLE PRECISION;

   DECLARE @V_OBSERVA_TXOBSITMSOL VARCHAR(2000);

   DECLARE @V_OPLOG_CDFILIOPELOG  VARCHAR(4);
   DECLARE @V_OPLOG_CDFORNECED    VARCHAR(21);
   DECLARE @V_OPLOG_CDEMPRESA     VARCHAR(2);
   DECLARE @V_OPLOG_IDTPFORPGTAF  VARCHAR(1);
   DECLARE @V_OPLOG_CDTIPCOB      VARCHAR(2);
   DECLARE @V_OPLOG_IDTIPOFRETAF  VARCHAR(1);
   DECLARE @V_OPLOG_CDFORMPGTO    VARCHAR(2);
   DECLARE @V_OPLOG_NRPARCPGTOAF  NUMERIC;
   DECLARE @V_OPLOG_NRDIAPGFIXAF  NUMERIC;
   DECLARE @V_OPLOG_IDUTDIAPGTAF  VARCHAR(1);
   DECLARE @V_OPLOG_IDTIPOEMITAF  VARCHAR(1);
   DECLARE @V_OPLOG_IDAFPRODWEB   VARCHAR(1);
   DECLARE @V_OPLOG_NRDIASPGTOAF  NUMERIC;
   DECLARE @V_OPLOG_VRPERCPGTOAF  DOUBLE PRECISION;
   DECLARE @V_OPLOG_NRSEQAPURAF   VARCHAR(10);
   DECLARE @V_OPLOG_CDFILDEST     VARCHAR(4);
   DECLARE @V_OPLOG_NRAUTOFORN    VARCHAR(10);

   DECLARE @V_AUX                 VARCHAR(20);
   DECLARE @V_NEW_DTPROGENTAF     DATETIME;

   DECLARE @V_ITOPLOG_CDMARCA     VARCHAR(4);
   DECLARE @V_ITOPLOG_CDPRODUTO   VARCHAR(20);
   DECLARE @V_ITOPLOG_DTPROGENTAF DATETIME;
   DECLARE @V_ITOPLOG_CDSEGMARCA  VARCHAR(4);
   DECLARE @V_ITOPLOG_VRPREUNIAF  DOUBLE PRECISION;
   DECLARE @V_ITOPLOG_VRPERDESAF  DOUBLE PRECISION;
   DECLARE @V_ITOPLOG_TXOBSITMAF  VARCHAR;
   DECLARE @V_ITOPLOG_VRDESCITMAF DOUBLE PRECISION;
   DECLARE @V_ITOPLOG_QTPROGENTAF DOUBLE PRECISION;

   DECLARE @V_OBSERVA_NRLOTEESTQ  VARCHAR(20);
   DECLARE @V_OBSERVA_NRSUBLOTE   VARCHAR(4);
   DECLARE @V_OBSERVA_CDPRODPROD  VARCHAR(10);
   DECLARE @V_OBSERVA_NMPRODUTO   VARCHAR(50);

   DECLARE @V_PRAZOPGTAF_NRDIASPGTOAF  INT;
   DECLARE @V_PRAZOPGTAF_VRPERCPGTOAF  FLOAT;

   DECLARE @V_VRARREDEMPE  FLOAT;
   DECLARE @V_QTPROGENTAF  DOUBLE PRECISION;
   DECLARE @V_IDUTEMPENHAF VARCHAR(1);
   DECLARE @V_AUTOFORN_NRCOLEITMAP  VARCHAR(10);
   DECLARE @V_AUTOFORN_NRLISTAITMAP VARCHAR(10);
   DECLARE @V_EMPRESA  VARCHAR(2);
   DECLARE @V_CDTPCTPAGAR  VARCHAR(6);
   DECLARE @V_IDGERAAF     VARCHAR(1);
   DECLARE @V_IDUTILCONSSOLIOL VARCHAR(1);
   DECLARE @V_MARCAPADRAO VARCHAR(5);
   DECLARE @V_MARCAITEM   VARCHAR(5);
   DECLARE @V_PRODUTOOL   VARCHAR(10);
   DECLARE @V_IDUTQTDISPGERAL VARCHAR(1);

   DECLARE @V_NRPEDIDOCOL VARCHAR(10);

   DECLARE @V_IDCONSOLAPUEFET VARCHAR(1);
   DECLARE @V_EXTRA           VARCHAR(1);
   DECLARE @V_NRPARCITMAF     VARCHAR(2);
   DECLARE @V_DTPROGENTAF1    DATETIME;

   DECLARE @V_VRPERAJFORNFIL  DOUBLE PRECISION;
   DECLARE @V_IDCONSPERPIAJPR VARCHAR(1);
   DECLARE @V_PIDSV           DOUBLE PRECISION;

   DECLARE @V_IDUTLPRCMPATIVO  VARCHAR(1);
   DECLARE @V_IDARREDCMPAMENOS VARCHAR(1);
   DECLARE @V_IDQTFRACIONADO   VARCHAR(1);
   DECLARE @V_CONTADOR         INT;
BEGIN
   SELECT
      @V_IDCONSOLAPUEFET = MAX(IDCONSOLAPUEFET)
   FROM APURPRECO
   WHERE CDFILCENTCMP = @P_CDCENTCMP
     AND NRAPURPREC = @P_NRSEQAPUR;

   IF @V_IDCONSOLAPUEFET = 'S' BEGIN
      SET @V_EXTRA = 'S';
   END
   ELSE BEGIN
      SET @V_EXTRA = 'N';
   END;

   SET @V_QTSOLIPROD = 0;
   SET @V_CONTADOR   = 0;
   SET @V_DSANTERIOR = NULL;

   SET @V_ANTCODIGO       = NULL;
   SET @V_ANTCDFILDEST    = NULL;
   SET @V_ANTCDFILLANC    = NULL;
   SET @V_ANTCDFORNECED   = NULL;
   SET @V_ANTIDTPFORPGTAF = NULL;
   SET @V_ANTCDTIPCOB     = NULL;
   SET @V_DTPROGENTAF     = NULL;

   SET @V_ANTIDTIPOEMITAF = NULL;
   SET @V_ANTCDEMPRESA    = NULL;
   SET @V_ANTIDTIPOFRETAF = NULL;
   SET @V_ANTCDFORMPGTO   = NULL;
   SET @V_ANTNRPARCPGTOAF = NULL;
   SET @V_ANTNRDIAPGFIXAF = NULL;
   SET @V_ANTIDUTDIAPGTAF = NULL;
   SET @V_ANTDSPZOPGTCONC = NULL;
   SET @V_ANTCONC_KEY     = NULL;

   SELECT
      @V_IDUTQTDEVOLU     = MAX(IDUTQTDEVOLU),
      @V_IDUTEMPENHAF     = MAX(IDUTEMPENHAF),
      @V_IDUTILCONSSOLIOL = ISNULL(MAX(IDUTILCONSSOLIOL), 'N'),
      @V_MARCAPADRAO      = MAX(CDMARCA),
      @V_IDUTQTDISPGERAL  = ISNULL(MAX(IDUTQTDISPGERAL), 'N'),
      @V_IDUTLPRCMPATIVO  = ISNULL(MAX(IDUTLPRCMPATIVO), 'N'),
      @V_IDARREDCMPAMENOS = ISNULL(MAX(IDARREDCMPAMENOS), 'N') /* Grava quantidade a comprar com valor arredondado para menos */
   FROM
      PARASUPRI
   WHERE
      CDFILIAL = @P_CDCENTCMP;

   SET @V_EMPRESA      = NULL;
   SET @V_CDTPCTPAGAR  = NULL;

   SELECT
      @V_EMPRESA = MAX(CDEMPRESA),
      @V_CDTPCTPAGAR = MAX(CDTPCTPAGAR)
   FROM
      COMPRA
   WHERE
      EXISTS (SELECT 1
              FROM ITMAPURPREC
              WHERE ITMAPURPREC.CDCENTITMAP = @P_CDCENTCMP AND
                    ITMAPURPREC.NRSEQITMAP  = @P_NRSEQAPUR AND
                    ITMAPURPREC.NRCOMPRA    = COMPRA.NRCOMPRA);

   IF @V_EMPRESA IS NOT NULL BEGIN
      SET @V_IDCOMPRA = 'S';
   END
   ELSE BEGIN
      SET @V_IDCOMPRA = 'N';
   END;

   DECLARE C_AUTOFORN CURSOR FOR
      SELECT
         CASE FORNECEDOR.IDGERAFDTENT
            WHEN 'S' THEN ITMAPURPREC.DTENTRAPUT
            ELSE NULL
         END AS DTENTRAPUT,
         ITMAPURPREC.CDMARCITMAP   AS CDMARCA,
         ITMAPURPREC.CDSEGMARCCOL  AS CDSEGMARCA,
         ITMAPURPREC.CDFILIAP      AS CDFILDEST,
         ISNULL(FILIAL.IDFUNCAOFILI, 'Z') AS IDFUNCAOFILI,
         @P_CDFILLANC              AS CDFILLANC,
         ITMAPURPREC.CDFORNITMAP   AS CDFORNECED,
         FORNECEDOR.IDTPFORPGTFO   IDTPFORPGTAP,
         ITMAPURPREC.CDTIPCOBAP    AS CDTIPCOB,
         ITMAPURPREC.DTENTRAPUT    AS DTPROGENTAF,
         ITMAPURPREC.QTACOMP       AS QTPROGENTAF,
         ITMAPURPREC.VRPRECUNIAP   AS VRPREUNIAF,
         ITMAPURPREC.VRPERDESIAP   AS VRPERDESAF,
         ITMAPURPREC.CDPRODITMAP   AS CDPRODUTO,
         ITMAPURPREC.IDTIPOEMITAP,
         ITMAPURPREC.CDEMPRESAAP   AS CDEMPRESA,
         ITMAPURPREC.IDTIPOFRETAP ,
         FORNECEDOR.CDFORMPGTO     AS CDFORMPGTO,
         FORNECEDOR.NRPARCPGTOFO  NRPARCPGTOAP,
         FORNECEDOR.NRDIAPGFIXFO  AS NRDIAPGFIXAF,
         FORNECEDOR.IDUTDIAPGTFO AS IDUTDIAPGTAF,
         ITMAPURPREC.DSPZOPGTCOAP,
         ISNULL(ITMAPURPREC.CONCKEYAP, '')     AS CONC_KEY,
         NULL AS IDAFOPERLOG,
         SUBSTRING(CONCKEYAP, LEN(CONCKEYAP)-1, 1) AS IDPRODWEB,
         ITMAPURPREC.CDCENTITMAP,
         ITMAPURPREC.CDREGITMAP,
         ITMAPURPREC.IDMOTIVPRESC,
         ITMAPURPREC.NRCOLEITMAP,
         ITMAPURPREC.NRLISTAITMAP,
         PRODUTO.CDARVPROD,
         FORNECEDOR.IDUTQTDISPFORN
      FROM
         ITMAPURPREC, FORNECEDOR, PRODUTO, FILIAL
      WHERE
         ITMAPURPREC.CDFILIAP     = FILIAL.CDFILIAL       AND
         ITMAPURPREC.CDPRODITMAP  = PRODUTO.CDPRODUTO     AND
         ITMAPURPREC.IDITMSELAPUR = 'S'                   AND
         ITMAPURPREC.CDFORNITMAP  = FORNECEDOR.CDFORNECED AND
         ITMAPURPREC.NRSEQITMAP   = @P_NRSEQAPUR          AND
         ITMAPURPREC.CDCENTITMAP  = @P_CDCENTCMP
      ORDER BY
         ITMAPURPREC.CDFILIAP,    ITMAPURPREC.CDCENTITMAP,
         ITMAPURPREC.CDFORNITMAP, ITMAPURPREC.IDTPFORPGTAP,
         ITMAPURPREC.CDTIPCOBAP,
         CASE FORNECEDOR.IDGERAFDTENT
            WHEN 'S' THEN ITMAPURPREC.DTENTRAPUT
            ELSE NULL
         END,
         ITMAPURPREC.IDTIPOEMITAP,  ITMAPURPREC.CDEMPRESAAP,
         ITMAPURPREC.IDTIPOFRETAP,  ITMAPURPREC.CDFORMPGTOAP,
         ITMAPURPREC.NRPARCPGTOAP,  ITMAPURPREC.NRDIAPGFIAP,
         ITMAPURPREC.IDULTDIAPGTAF,
         CONVERT(VARCHAR, ITMAPURPREC.DSPZOPGTCOAP),
         ITMAPURPREC.CONCKEYAP,
         ITMAPURPREC.DTENTRAPUT;
   OPEN C_AUTOFORN;
   FETCH NEXT FROM C_AUTOFORN INTO @V_AUTOFORN_DTENTRAPUT,
                                   @V_AUTOFORN_CDMARCA,
                                   @V_AUTOFORN_CDSEGMARCA,
                                   @V_AUTOFORN_CDFILDEST,
                                   @V_AUTOFORN_IDFUNCAOFILI,
                                   @V_AUTOFORN_CDFILLANC,
                                   @V_AUTOFORN_CDFORNECED,
                                   @V_AUTOFORN_IDTPFORPGTAP,
                                   @V_AUTOFORN_CDTIPCOB,
                                   @V_AUTOFORN_DTPROGENTAF,
                                   @V_AUTOFORN_QTPROGENTAF,
                                   @V_AUTOFORN_VRPREUNIAF,
                                   @V_AUTOFORN_VRPERDESAF,
                                   @V_AUTOFORN_CDPRODUTO,
                                   @V_AUTOFORN_IDTIPOEMITAP,
                                   @V_AUTOFORN_CDEMPRESA,
                                   @V_AUTOFORN_IDTIPOFRETAP,
                                   @V_AUTOFORN_CDFORMPGTO,
                                   @V_AUTOFORN_NRPARCPGTOAP,
                                   @V_AUTOFORN_NRDIAPGFIXAF,
                                   @V_AUTOFORN_IDUTDIAPGTAF,
                                   @V_AUTOFORN_DSPZOPGTCOAP,
                                   @V_AUTOFORN_CONC_KEY,
                                   @V_AUTOFORN_IDAFOPERLOG,
                                   @V_AUTOFORN_IDPRODWEB,
                                   @V_AUTOFORN_CDCENTITMAP,
                                   @V_AUTOFORN_CDREGITMAP,
                                   @V_AUTOFORN_IDMOTIVPRESC,
                                   @V_AUTOFORN_NRCOLEITMAP,
                                   @V_AUTOFORN_NRLISTAITMAP,
                                   @V_AUTOFORN_CDARVPROD,
                                   @V_AUTOFORN_IDUTQTDISPFORN
                                   ;
   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_IDCOMPRA = 'N' BEGIN
         SET @V_EMPRESA = @V_AUTOFORN_CDEMPRESA;
      END;

      IF (@V_IDUTILCONSSOLIOL = 'S') AND (@V_AUTOFORN_IDFUNCAOFILI = 'O') BEGIN
         SET @V_MARCAITEM = @V_MARCAPADRAO;
         SET @V_PRODUTOOL = NULL
         SELECT
            @V_PRODUTOOL = MAX(CDPRODARVOL)
         FROM
            RELACPRODOL
         WHERE RELACPRODOL.CDPRARVORIG = @V_AUTOFORN_CDPRODUTO
           AND RELACPRODOL.CDMARCA     = @V_AUTOFORN_CDMARCA;

         IF @V_PRODUTOOL IS NULL BEGIN
            SET @V_IDGERAAF = 'N';
         END
         ELSE BEGIN
            SET @V_IDGERAAF = 'S';
         END;
      END
      ELSE BEGIN
         SET @V_MARCAITEM  = NULL;
         SET @V_IDGERAAF   = 'S';
         SET @V_PRODUTOOL  = NULL;
      END;

      IF @V_IDGERAAF = 'S' BEGIN
         SET @V_QTPROGENTAF = @V_AUTOFORN_QTPROGENTAF;

         IF @V_IDUTEMPENHAF = 'S' BEGIN
            SET @V_VRARREDEMPE = 0;

            SELECT
               @V_VRARREDEMPE = ISNULL(MAX(VRARREDEMPMAR), 0)
            FROM
               MARCPROD
            WHERE
               (CDMARCA   = @V_AUTOFORN_CDMARCA) AND
               (CDPRODUTO IN (SELECT
                                 P.CDPRODUTO
                              FROM
                                 PRODUTO P
                              WHERE
                                 P.CDPRODUTO = MARCPROD.CDPRODUTO AND
                                 @V_AUTOFORN_CDARVPROD LIKE P.CDARVPROD + '%') );

            IF @V_VRARREDEMPE = 0 BEGIN
               SELECT
                  @V_VRARREDEMPE = ISNULL(MAX(VRARREDEMPE), 0)
               FROM
                  PRODFORNCOMP
               WHERE
                  CDPRODCOMPL = ISNULL(@V_PRODUTOOL, @V_AUTOFORN_CDPRODUTO) AND
                  CDFORNECED = @V_AUTOFORN_CDFORNECED;
            END;

            IF @V_VRARREDEMPE > 0 BEGIN
               IF (((CAST(@V_QTPROGENTAF AS DOUBLE PRECISION) / @V_VRARREDEMPE) - (ROUND(@V_QTPROGENTAF / @V_VRARREDEMPE, 0, 1))) <> 0) AND @V_VRARREDEMPE > 0
               BEGIN
                  SET @V_QTPROGENTAF = CEILING(CAST(@V_QTPROGENTAF AS DOUBLE PRECISION) / @V_VRARREDEMPE) * @V_VRARREDEMPE;
               END;
            END;
         END;

         EXEC CARREGA_PERIFORN @V_AUTOFORN_CDFILDEST, @V_AUTOFORN_CDFORNECED, @V_AUTOFORN_DTPROGENTAF, @P_NEW_DTPROGENTAF = @V_NEW_DTPROGENTAF OUTPUT;

         IF @V_AUTOFORN_DTENTRAPUT IS NULL BEGIN
            SET @V_DSATUAL = @V_AUTOFORN_CDFILDEST    + @V_AUTOFORN_CDFILLANC    +
                             @V_AUTOFORN_CDFORNECED   + ISNULL(@V_AUTOFORN_IDTPFORPGTAP, '') +
                             ISNULL(@V_AUTOFORN_CDTIPCOB, '')     + '' +
                             @V_AUTOFORN_IDTIPOEMITAP + @V_EMPRESA    +
                             ISNULL(@V_AUTOFORN_IDTIPOFRETAP, '') + ISNULL(@V_AUTOFORN_CDFORMPGTO, '')   +
                             ISNULL(CONVERT(VARCHAR, @V_AUTOFORN_NRPARCPGTOAP), '') + ISNULL(CONVERT(VARCHAR, @V_AUTOFORN_NRDIAPGFIXAF), '') +
                             ISNULL(@V_AUTOFORN_IDUTDIAPGTAF, '') + ISNULL(CONVERT(VARCHAR, @V_AUTOFORN_DSPZOPGTCOAP), '') +
                             @V_AUTOFORN_CONC_KEY;
         END
         ELSE BEGIN
            SET @V_DSATUAL = @V_AUTOFORN_CDFILDEST    + @V_AUTOFORN_CDFILLANC    +
                             @V_AUTOFORN_CDFORNECED   + ISNULL(@V_AUTOFORN_IDTPFORPGTAP, '') +
                             ISNULL(@V_AUTOFORN_CDTIPCOB, '')     + CONVERT(VARCHAR,@V_AUTOFORN_DTENTRAPUT,103) +
                             @V_AUTOFORN_IDTIPOEMITAP + @V_EMPRESA    +
                             ISNULL(@V_AUTOFORN_IDTIPOFRETAP, '') + ISNULL(@V_AUTOFORN_CDFORMPGTO, '')   +
                             ISNULL(CONVERT(VARCHAR, @V_AUTOFORN_NRPARCPGTOAP), '') + ISNULL(CONVERT(VARCHAR, @V_AUTOFORN_NRDIAPGFIXAF), '') +
                             ISNULL(@V_AUTOFORN_IDUTDIAPGTAF, '') + ISNULL(CONVERT(VARCHAR, @V_AUTOFORN_DSPZOPGTCOAP), '') +
                             @V_AUTOFORN_CONC_KEY;
         END;

         IF @V_IDARREDCMPAMENOS = 'S' BEGIN
            SELECT @V_DSANTERIOR_AUX = MAX(@V_AUTOFORN_CDFILDEST    + @V_AUTOFORN_CDFILLANC    +
                                           @V_AUTOFORN_CDFORNECED   + ISNULL(@V_AUTOFORN_IDTPFORPGTAP, '') +
                                           ISNULL(@V_AUTOFORN_CDTIPCOB, '')     + ISNULL(CONVERT(VARCHAR,@V_AUTOFORN_DTENTRAPUT,103), '') +
                                           @V_AUTOFORN_IDTIPOEMITAP + @V_EMPRESA    +
                                           ISNULL(@V_AUTOFORN_IDTIPOFRETAP, '') + ISNULL(@V_AUTOFORN_CDFORMPGTO, '')   +
                                           ISNULL(CONVERT(VARCHAR, @V_AUTOFORN_NRPARCPGTOAP), '') + ISNULL(CONVERT(VARCHAR, @V_AUTOFORN_NRDIAPGFIXAF), '') +
                                           ISNULL(@V_AUTOFORN_IDUTDIAPGTAF, '') + ISNULL(CONVERT(VARCHAR, @V_AUTOFORN_DSPZOPGTCOAP), '') +
                                           @V_AUTOFORN_CONC_KEY),
                   @V_CODIGO_AUX = MAX(AUTOFORNE.NRAUTOFORN)
              FROM AUTOFORNE, APURPRECO, ITMAPURPREC, ITEMAUTF
             WHERE APURPRECO.CDFILCENTCMP   = ITMAPURPREC.CDCENTITMAP
               AND APURPRECO.NRAPURPREC     = ITMAPURPREC.NRSEQITMAP
               AND APURPRECO.NRAPURPREC     = AUTOFORNE.NRSEQAPURAF
               AND APURPRECO.CDFILLANC      = AUTOFORNE.CDFILLANC
               AND AUTOFORNE.CDFILDEST      = ITMAPURPREC.CDFILIAP
               AND AUTOFORNE.CDFORNECED     = @V_AUTOFORN_CDFORNECED
               AND AUTOFORNE.CDFILDEST      = @V_AUTOFORN_CDFILDEST

               AND AUTOFORNE.CDFILDEST      = ITEMAUTF.CDFILDEST
               AND AUTOFORNE.CDFILLANC      = ITEMAUTF.CDFILLANC
               AND AUTOFORNE.NRAUTOFORN     = ITEMAUTF.NRAUTOFORN

               AND @V_AUTOFORN_CDFILDEST    + @V_AUTOFORN_CDFILLANC    +
                   @V_AUTOFORN_CDFORNECED   + ISNULL(@V_AUTOFORN_IDTPFORPGTAP, '') +
                   ISNULL(@V_AUTOFORN_CDTIPCOB, '')     + ISNULL(CONVERT(VARCHAR,@V_AUTOFORN_DTENTRAPUT,103), '') +
                   @V_AUTOFORN_IDTIPOEMITAP + @V_EMPRESA    +
                   ISNULL(@V_AUTOFORN_IDTIPOFRETAP, '') + ISNULL(@V_AUTOFORN_CDFORMPGTO, '')   +
                   ISNULL(CONVERT(VARCHAR, @V_AUTOFORN_NRPARCPGTOAP), '') + ISNULL(CONVERT(VARCHAR, @V_AUTOFORN_NRDIAPGFIXAF), '') +
                   ISNULL(@V_AUTOFORN_IDUTDIAPGTAF, '') + ISNULL(CONVERT(VARCHAR, @V_AUTOFORN_DSPZOPGTCOAP), '') +
                   @V_AUTOFORN_CONC_KEY = @V_DSATUAL
               AND ITMAPURPREC.IDITMSELAPUR = 'S'
               AND APURPRECO.CDFILCENTCMP   = @P_CDCENTCMP
               AND APURPRECO.NRAPURPREC     = @P_NRSEQAPUR
               AND ITEMAUTF.DTENTRITMSOL    = @V_AUTOFORN_DTPROGENTAF;

            IF ((@V_DSANTERIOR_AUX IS NOT NULL) AND (@V_CODIGO_AUX IS NOT NULL)) BEGIN
               SET @V_DSANTERIOR = @V_DSANTERIOR_AUX;
               SET @V_CODIGO     = @V_CODIGO_AUX;
            END;
         END;

         IF (@V_DSATUAL <> @V_DSANTERIOR) OR (@V_DSANTERIOR IS NULL) BEGIN
            SET @V_NRITEMAF = 0;
            SELECT @V_NRITEMAF = ISNULL(NRITEMAF, 0)
            FROM FORNECEDOR
            WHERE CDFORNECED = @V_AUTOFORN_CDFORNECED;
            SET @V_CONT = 1;
            SET @V_NOVOCODIGO = 'AUTOFORNE';
            EXEC NOVO_CODIGO @V_NOVOCODIGO, @P_SEQUENCIAL = @V_CODIGO OUTPUT;
            SET @V_CODIGO = SUBSTRING(@V_CODIGO, 11, 10);
            INSERT INTO AUTOFORNE
               (CDFILDEST,    CDFILLANC,    NRAUTOFORN,   CDOPERADOR,   DTAUTOFORN,
                IDTPFORPGTAF, IDTIPOEMITAF, IDTIPOFRETAF, NRPARCPGTOAF, NRDIAPGFIXAF,
                IDUTDIAPGTAF, CDTIPCOB,     CDEMPRESA,    CDFORMPGTO,   CDFORNECED,
                NRSEQAPURAF,  IDAFPRODWEB,  IDAFOPERLOG,  IDTIPOLANCAF, IDBAIXAAF, IDAFCONS, DSCONCKEYAF, CDTPCTPAGAR,
                IDAUTOFORNEX)
            VALUES
               (@V_AUTOFORN_CDFILDEST,    @V_AUTOFORN_CDFILLANC,    @V_CODIGO,
                @P_CDOPERADOR,            @P_DTAUTOFORN,            @V_AUTOFORN_IDTPFORPGTAP,
                @V_AUTOFORN_IDTIPOEMITAP, @V_AUTOFORN_IDTIPOFRETAP, @V_AUTOFORN_NRPARCPGTOAP,
                @V_AUTOFORN_NRDIAPGFIXAF, @V_AUTOFORN_IDUTDIAPGTAF, @V_AUTOFORN_CDTIPCOB,
                @V_EMPRESA,    @V_AUTOFORN_CDFORMPGTO,   @V_AUTOFORN_CDFORNECED,
                @P_NRSEQAPUR,            @V_AUTOFORN_IDPRODWEB,    @V_AUTOFORN_IDAFOPERLOG, 'A', '6', 'N', @V_AUTOFORN_CONC_KEY, @V_CDTPCTPAGAR,
                @V_EXTRA);

            IF ISNULL(@V_AUTOFORN_IDTPFORPGTAP, '') = 'V' BEGIN
               DECLARE C_PRAZOPGTAF CURSOR FOR
                  SELECT NRDIASPGTOFO, VRPERCPGTOFO
                    FROM PRAZOPGTFORN
                   WHERE CDFORNECED = @V_AUTOFORN_CDFORNECED
               OPEN C_PRAZOPGTAF;
               FETCH NEXT FROM C_PRAZOPGTAF
                          INTO @V_PRAZOPGTAF_NRDIASPGTOAF,
                               @V_PRAZOPGTAF_VRPERCPGTOAF;

               WHILE (@@FETCH_STATUS = 0) BEGIN
                  INSERT
                    INTO PRAZOPGTAF (CDFILDEST, CDFILLANC, NRAUTOFORN, NRDIASPGTOAF, VRPERCPGTOAF)
                  VALUES (@V_AUTOFORN_CDFILDEST, @V_AUTOFORN_CDFILLANC, @V_CODIGO,
                          @V_PRAZOPGTAF_NRDIASPGTOAF, @V_PRAZOPGTAF_VRPERCPGTOAF);

                  FETCH NEXT FROM C_PRAZOPGTAF
                             INTO @V_PRAZOPGTAF_NRDIASPGTOAF,
                                  @V_PRAZOPGTAF_VRPERCPGTOAF;
               END;
               CLOSE C_PRAZOPGTAF;
               DEALLOCATE C_PRAZOPGTAF;
            END;
         END
         ELSE BEGIN
            SET @V_CONT = @V_CONT + 1;
            IF (@V_CONT > @V_NRITEMAF) AND (@V_NRITEMAF > 0) BEGIN
               /* SE ALGUM PRODUTO FOR FRACIONADO, UPDATA A APURAO PARA HABILITAR O BOTO DE APURAR NOVAMENTE */
               IF @V_IDARREDCMPAMENOS = 'S' BEGIN
                  SELECT @V_IDQTFRACIONADO = ISNULL(MAX('S'), 'N')
                    FROM AUTOFORNE A, ITEMAUTF I, FILIAL F
                   WHERE I.CDFILDEST   = A.CDFILDEST
                     AND I.CDFILLANC   = A.CDFILLANC
                     AND I.NRAUTOFORN  = A.NRAUTOFORN
                     AND A.CDFILDEST   = F.CDFILIAL
                     AND A.NRSEQAPURAF = @P_NRSEQAPUR
                     AND CASE WHEN F.CDFILCENTCMP IS NULL THEN F.CDFILIAL ELSE F.CDFILCENTCMP END = @P_CDCENTCMP
                     AND FLOOR(I.QTPROGENTAF) <> I.QTPROGENTAF;

                  IF @V_IDQTFRACIONADO = 'S' BEGIN
                     SET @V_CONTADOR = @V_CONTADOR + 1;
                  END;
               END;

               -- FECHAMENTO_AF;
               -- GERA-PARCELAS

               SET @V_NRPARCITMAF = '00';

               DECLARE C_NRPARCITMAF CURSOR FOR
                SELECT DISTINCT ITEMAUTF.DTPROGENTAF
                 FROM ITEMAUTF
                WHERE (ITEMAUTF.CDFILDEST  = @V_ANTCDFILDEST) AND
                      (ITEMAUTF.CDFILLANC  = @V_ANTCDFILLANC) AND
                      (ITEMAUTF.NRAUTOFORN = @V_ANTCODIGO)
                 ORDER BY DTPROGENTAF
               OPEN C_NRPARCITMAF;
               FETCH NEXT FROM C_NRPARCITMAF INTO @V_DTPROGENTAF1
               WHILE (@@FETCH_STATUS = 0) BEGIN
                  SET @V_NRPARCITMAF = RIGHT(REPLICATE('0', 2) + CONVERT(VARCHAR, CONVERT(DOUBLE PRECISION, @V_NRPARCITMAF) + 1), 2);
                  UPDATE ITEMAUTF
                  SET ITEMAUTF.NRPARCITMAF = @V_NRPARCITMAF,
                      ITEMAUTF.QTPROGENTAF = CASE @V_IDARREDCMPAMENOS
                                                WHEN 'S'
                                                THEN CASE ISNULL(FLOOR(ITEMAUTF.QTPROGENTAF), 1)
                                                        WHEN 0
                                                        THEN ITEMAUTF.QTPROGENTAF
                                                        ELSE ISNULL(FLOOR(ITEMAUTF.QTPROGENTAF), 1)
                                                     END
                                                ELSE ITEMAUTF.QTPROGENTAF
                                             END
                  WHERE
                     (ITEMAUTF.CDFILDEST    = @V_ANTCDFILDEST) AND
                     (ITEMAUTF.CDFILLANC    = @V_ANTCDFILLANC) AND
                     (ITEMAUTF.NRAUTOFORN   = @V_ANTCODIGO)   AND
                     (ITEMAUTF.DTPROGENTAF  = @V_DTPROGENTAF1);
                  FETCH NEXT FROM C_NRPARCITMAF INTO @V_DTPROGENTAF1
               END;
               CLOSE C_NRPARCITMAF;
               DEALLOCATE C_NRPARCITMAF;

               SET @V_CDINSCESTA = NULL;

               SELECT @V_CDINSCESTA = MIN(CDINSCESTA)
                 FROM INSCRESTAD
                WHERE (CDEMPRESA = @V_ANTCDEMPRESA);

               SET @V_DTPROGENTAF = NULL;

               SELECT @V_DTPROGENTAF = MIN(DTPROGENTAF)
               FROM ITEMAUTF
               WHERE (CDFILDEST  = @V_ANTCDFILDEST)  AND
                     (CDFILLANC  = @V_ANTCDFILLANC)  AND
                     (NRAUTOFORN = @V_ANTCODIGO);

               EXEC IMPOSTO_ITEMAF @V_ANTCDEMPRESA,
                                   @V_CDINSCESTA,
                                   @V_ANTCDFORNECED,
                                   @V_ANTCDFILDEST,
                                   @V_ANTCDFILLANC,
                                   @V_ANTCODIGO,
                                   @V_DTPROGENTAF;
               -- qryValor_AF

               SET @V_VRPRODUTO  = NULL;
               SET @V_VRDESCONTO = NULL;
               SELECT
                  @V_VRPRODUTO  = SUM(ITEMAUTF.QTPROGENTAF * ITEMAUTF.VRPREUNIAF),
                  @V_VRDESCONTO = SUM((ITEMAUTF.QTPROGENTAF * ITEMAUTF.VRPREUNIAF * ISNULL(ITEMAUTF.VRPERDESAF, 0)) / 100)
               FROM
                  ITEMAUTF
               WHERE
                  (ITEMAUTF.CDFILDEST  = @V_ANTCDFILDEST) AND
                  (ITEMAUTF.CDFILLANC  = @V_ANTCDFILLANC) AND
                  (ITEMAUTF.NRAUTOFORN = @V_ANTCODIGO);
               SET @V_VRIMPOSTO = 0;
               SELECT
                  @V_VRIMPOSTO = ISNULL(SUM(IMPITMAF.VRADIMPAF), 0)
               FROM
                  IMPITMAF,
                  ITEMAUTF,
                  IMPOSTO
               WHERE
                  (IMPITMAF.CDFILDEST   = @V_ANTCDFILDEST)       AND
                  (IMPITMAF.CDFILLANC   = @V_ANTCDFILLANC)       AND
                  (IMPITMAF.NRAUTOFORN  = @V_ANTCODIGO)          AND
                  (IMPITMAF.CDFILDEST   = ITEMAUTF.CDFILDEST)    AND
                  (IMPITMAF.CDFILLANC   = ITEMAUTF.CDFILLANC)    AND
                  (IMPITMAF.NRAUTOFORN  = ITEMAUTF.NRAUTOFORN)   AND
                  (IMPITMAF.CDPRODUTO   = ITEMAUTF.CDPRODUTO)    AND
                  (IMPITMAF.CDMARCA     = ITEMAUTF.CDMARCA)      AND
                  (IMPITMAF.DTPROGENTAF = ITEMAUTF.DTPROGENTAF)  AND
                  (IMPITMAF.CDIMPOSTO   = IMPOSTO.CDIMPOSTO)     AND
                   ISNULL(IMPOSTO.IDACRPRODENTRNF, 'N') = 'N';

               UPDATE AUTOFORNE
               SET VRTOTALAF = @V_VRPRODUTO - @V_VRDESCONTO + @V_VRIMPOSTO
               WHERE
                  (CDFILDEST   = @V_ANTCDFILDEST) AND
                  (CDFILLANC   = @V_ANTCDFILLANC) AND
                  (NRAUTOFORN  = @V_ANTCODIGO);
               -- GEROU
               SET @V_NOVOCODIGO = 'AUTOFORNE';
               EXEC NOVO_CODIGO @V_NOVOCODIGO, @P_SEQUENCIAL = @V_CODIGO OUTPUT;
               SET @V_CODIGO = SUBSTRING(@V_CODIGO, 11, 10);
               INSERT INTO AUTOFORNE
                  (CDFILDEST,    CDFILLANC,    NRAUTOFORN,   CDOPERADOR,   DTAUTOFORN,
                   IDTPFORPGTAF, IDTIPOEMITAF, IDTIPOFRETAF, NRPARCPGTOAF, NRDIAPGFIXAF,
                   IDUTDIAPGTAF, CDTIPCOB,     CDEMPRESA,    CDFORMPGTO,   CDFORNECED,
                   NRSEQAPURAF,  IDAFPRODWEB,  IDAFOPERLOG,  IDTIPOLANCAF, IDBAIXAAF, IDAFCONS, DSCONCKEYAF, CDTPCTPAGAR,
                   IDAUTOFORNEX)
               VALUES
                  (@V_AUTOFORN_CDFILDEST,    @V_AUTOFORN_CDFILLANC,    @V_CODIGO,
                   @P_CDOPERADOR,            @P_DTAUTOFORN,            @V_AUTOFORN_IDTPFORPGTAP,
                   @V_AUTOFORN_IDTIPOEMITAP, @V_AUTOFORN_IDTIPOFRETAP, @V_AUTOFORN_NRPARCPGTOAP,
                   @V_AUTOFORN_NRDIAPGFIXAF, @V_AUTOFORN_IDUTDIAPGTAF, @V_AUTOFORN_CDTIPCOB,
                   @V_EMPRESA,    @V_AUTOFORN_CDFORMPGTO,   @V_AUTOFORN_CDFORNECED,
                   @P_NRSEQAPUR,             @V_AUTOFORN_IDPRODWEB,    @V_AUTOFORN_IDAFOPERLOG, 'A', '6', 'N', @V_AUTOFORN_CONC_KEY, @V_CDTPCTPAGAR,
                   @V_EXTRA);
               IF ISNULL(@V_AUTOFORN_IDTPFORPGTAP, '') = 'V' BEGIN
                  DECLARE C_PRAZOPGTAF CURSOR FOR
                     SELECT NRDIASPGTOFO, VRPERCPGTOFO
                       FROM PRAZOPGTFORN
                      WHERE CDFORNECED = @V_AUTOFORN_CDFORNECED
                  OPEN C_PRAZOPGTAF;
                  FETCH NEXT FROM C_PRAZOPGTAF
                             INTO @V_PRAZOPGTAF_NRDIASPGTOAF,
                                  @V_PRAZOPGTAF_VRPERCPGTOAF;
                  WHILE (@@FETCH_STATUS = 0) BEGIN
                     INSERT
                       INTO PRAZOPGTAF (CDFILDEST, CDFILLANC, NRAUTOFORN, NRDIASPGTOAF, VRPERCPGTOAF)
                     VALUES (@V_AUTOFORN_CDFILDEST, @V_AUTOFORN_CDFILLANC, @V_CODIGO,
                             @V_PRAZOPGTAF_NRDIASPGTOAF, @V_PRAZOPGTAF_VRPERCPGTOAF);

                     FETCH NEXT FROM C_PRAZOPGTAF
                                INTO @V_PRAZOPGTAF_NRDIASPGTOAF,
                                     @V_PRAZOPGTAF_VRPERCPGTOAF;
                  END;
                  CLOSE C_PRAZOPGTAF;
                  DEALLOCATE C_PRAZOPGTAF;
               END;
                SET @V_CONT = 1;
            END;
         END;

         SET @V_OBSSOL = '';

         DECLARE C_OBSERVA CURSOR FOR
            SELECT ITEMSOLI.TXOBSITMSOL, ITEMSOLI.NRLOTEESTQ,
                   ITEMSOLI.NRSUBLOTE, ITEMSOLI.CDPRODPROD,
                   PRODUTO.NMPRODUTO
            FROM ITEMSOLI LEFT JOIN PRODUTO
                                 ON ITEMSOLI.CDPRODPROD = PRODUTO.CDPRODUTO
            WHERE
               (ITEMSOLI.CDFILSOLI  = @V_AUTOFORN_CDFILDEST) AND
               (ITEMSOLI.CDPRODUTO  = @V_AUTOFORN_CDPRODUTO) AND
               (ITEMSOLI.DTPROGENTR = @V_AUTOFORN_DTPROGENTAF)
         OPEN C_OBSERVA;
         FETCH NEXT FROM C_OBSERVA INTO @V_OBSERVA_TXOBSITMSOL, @V_NRLOTEESTQ,
                                        @V_NRSUBLOTE, @V_CDPRODPROD, @V_NMPRODPROD;
         WHILE (@@FETCH_STATUS = 0) BEGIN
            SET @V_OBSSOL     = @V_OBSSOL + @V_OBSERVA_TXOBSITMSOL;
            SET @V_NRLOTEESTQ = @V_OBSERVA_NRLOTEESTQ;
            SET @V_NRSUBLOTE  = @V_OBSERVA_NRSUBLOTE;
            SET @V_CDPRODPROD = @V_OBSERVA_CDPRODPROD;
            SET @V_NMPRODPROD = @V_OBSERVA_NMPRODUTO;
            FETCH NEXT FROM C_OBSERVA INTO @V_OBSERVA_TXOBSITMSOL, @V_NRLOTEESTQ,
                                           @V_NRSUBLOTE, @V_CDPRODPROD, @V_NMPRODPROD;
         END;
         CLOSE C_OBSERVA;
         DEALLOCATE C_OBSERVA;
         IF @V_NRLOTEESTQ + @V_NRSUBLOTE + @V_NMPRODPROD IS NOT NULL BEGIN/*INFORMAES DO LOTE NA OBSERVAO*/
            SET @V_OBSSOL = 'Lote: '+ @V_NRLOTEESTQ + ' SubLote: ' + @V_NRSUBLOTE + ' Produto: ' + @V_NMPRODPROD + CHAR(13) + CHAR(10) + @V_OBSSOL;
         END;
         SET @V_CDPERIENTR = NULL;
         SET @V_IDTIPODIA  = NULL;
         SELECT
           @V_CDPERIENTR = MAX(REFORFIL.CDPERIENTR),
           @V_IDTIPODIA  = MAX(PERIENTR.IDTIPODIA)
         FROM
            REFORFIL, PERIENTR
         WHERE
            REFORFIL.CDPERIENTR = PERIENTR.CDPERIENTR AND
            REFORFIL.CDFORNECED = @V_AUTOFORN_CDFORNECED;
         SET @V_COUNT_AUX    = 0;
         SET @V_DTENTRITMSOL = NULL;
         SELECT @V_COUNT_AUX    = COUNT(*),
                @V_DTENTRITMSOL = MAX(DTENTRITMSOL)
         FROM ITEMAUTF
         WHERE CDFILDEST   = @V_AUTOFORN_CDFILDEST                       AND
               CDFILLANC   = @V_AUTOFORN_CDFILLANC                       AND
               NRAUTOFORN  = @V_CODIGO                                   AND
               CDPRODUTO   = ISNULL(@V_PRODUTOOL, @V_AUTOFORN_CDPRODUTO) AND
               ((CDMARCA   = ISNULL(@V_MARCAITEM, @V_AUTOFORN_CDMARCA))  OR
               (VRPREUNIAF  = @V_AUTOFORN_VRPREUNIAF))   AND
               DTPROGENTAF = @V_NEW_DTPROGENTAF;
         IF @V_COUNT_AUX = 0 BEGIN
            IF @V_AUTOFORN_DTPROGENTAF <> @V_NEW_DTPROGENTAF BEGIN
               SET @V_VRPRECUNIITM = NULL;
               SELECT @V_VRPRECUNIITM = MIN(VRPRECUNIITM)
               FROM ITEMCOLE
               WHERE
                  CDFILIAL = @V_AUTOFORN_CDCENTITMAP   AND
                  CDREGIAO = @V_AUTOFORN_CDREGITMAP    AND
                  CDFORNECED = @V_AUTOFORN_CDFORNECED  AND
                  CDPRODUTO = @V_AUTOFORN_CDPRODUTO    AND
                  CDMARCA = @V_AUTOFORN_CDMARCA        AND
                  @V_NEW_DTPROGENTAF BETWEEN DTINIVALITM AND DTFINVALITM;
               IF ISNULL(@V_VRPRECUNIITM, 0) = 0 BEGIN
                  SET @V_VRPRECUNIITM = @V_AUTOFORN_VRPREUNIAF;
               END;
            END
            ELSE BEGIN
               SET @V_VRPRECUNIITM = @V_AUTOFORN_VRPREUNIAF;
            END;
            SET @V_VRDESCITMAF = 0;
            SET @V_VRDESCITMAF = (@V_QTPROGENTAF * @V_VRPRECUNIITM * @V_AUTOFORN_VRPERDESAF)/100;
            SET @V_QTVOLUITEMSO = 0;
            IF @V_IDUTQTDEVOLU = 'S' BEGIN
               SET @V_QTVOLUITEMSO = NULL;
               SELECT @V_QTVOLUITEMSO = SUM(QTVOLUITEMSO)
               FROM ITEMSOLI
               WHERE CDFILSOLI = @V_AUTOFORN_CDFILDEST AND
                     DTPROGENTR = @V_AUTOFORN_DTPROGENTAF AND
                     CDPRODUTO = @V_AUTOFORN_CDPRODUTO AND
                     IDITMCONS = 'N';
            END;

            SET @V_VRPERAJFORNFIL = NULL;
            SET @V_IDCONSPERPIAJPR = 'N';
            SELECT
               @V_VRPERAJFORNFIL = MAX(VRPERAJFORNFIL),
               @V_IDCONSPERPIAJPR = MAX(IDCONSPERPIAJPR)
            FROM AJUSTEPRFORNFIL
            WHERE AJUSTEPRFORNFIL.CDFORNECED = @V_AUTOFORN_CDFORNECED
              AND AJUSTEPRFORNFIL.CDFILIAL = @V_AUTOFORN_CDFILDEST
              AND AJUSTEPRFORNFIL.DTINIAJPRFORFIL = (SELECT MAX(A.DTINIAJPRFORFIL)
                                                     FROM AJUSTEPRFORNFIL A
                                                     WHERE A.CDFORNECED = @V_AUTOFORN_CDFORNECED
                                                       AND A.CDFILIAL = @V_AUTOFORN_CDFILDEST
                                                       AND CONVERT(DATETIME, CONVERT(VARCHAR, GETDATE(), 103), 103)
                                                           BETWEEN A.DTINIAJPRFORFIL AND ISNULL(A.DTFINAJPRFORFIL, CONVERT(DATETIME, CONVERT(VARCHAR, GETDATE(), 103), 103)));

            SET @V_PIDSV = NULL;
            IF @V_IDCONSPERPIAJPR = 'S' BEGIN
               SELECT
                  @V_PIDSV = MAX(VRPERPIPRFO)
               FROM PRODFORNCOMP
               WHERE PRODFORNCOMP.CDFORNECED  = @V_AUTOFORN_CDFORNECED
                 AND PRODFORNCOMP.CDPRODCOMPL = ISNULL(@V_PRODUTOOL, @V_AUTOFORN_CDPRODUTO);

               IF @V_PIDSV IS NULL BEGIN
                  SELECT @V_PIDSV = MAX(VRPERPIFORN)
                  FROM FORNECEDOR
                  WHERE FORNECEDOR.CDFORNECED = @V_AUTOFORN_CDFORNECED;
               END;
            END;

            IF @V_PIDSV IS NULL BEGIN
               SET @V_PIDSV = 0;
            END;
            IF @V_VRPERAJFORNFIL IS NULL BEGIN
               SET @V_VRPERAJFORNFIL = 0;
            END;

            SET @V_VRPRECUNIITM = @V_VRPRECUNIITM - (@V_VRPRECUNIITM * @V_PIDSV/100) + (@V_VRPRECUNIITM * @V_VRPERAJFORNFIL/100);

            INSERT INTO ITEMAUTF
               (CDFILDEST,    CDFILLANC,   NRAUTOFORN,   CDPRODUTO,
                CDMARCA,      DTPROGENTAF, CDSEGMARCA,   QTPROGENTAF,
                VRPREUNIAF,   VRPERDESAF,  TXOBSITMAF,   VRDESCITMAF,
                NRLOTEESTQ,   NRSUBLOTE,   CDPRODPRODAF, DTENTRITMSOL,
                QTVOLUITEMAF, IDMOTPRESCAF, IDTPLANITEAF, CDFILCOTITAF,
                NRCOTPREITAF, CDMARCOTITAF, CDREGCOTITAF, CDFORCOTITAF,
                CDPROCOTITAF, NRLISTAITAF)
            VALUES
               (@V_AUTOFORN_CDFILDEST, @V_AUTOFORN_CDFILLANC,  @V_CODIGO,              ISNULL(@V_PRODUTOOL, @V_AUTOFORN_CDPRODUTO),
                ISNULL(@V_MARCAITEM, @V_AUTOFORN_CDMARCA),   @V_NEW_DTPROGENTAF,     @V_AUTOFORN_CDSEGMARCA, @V_QTPROGENTAF,
                @V_VRPRECUNIITM,       @V_AUTOFORN_VRPERDESAF, @V_OBSSOL,              @V_VRDESCITMAF,
                @V_NRLOTEESTQ,         @V_NRSUBLOTE,           @V_CDPRODPROD,          @V_AUTOFORN_DTPROGENTAF,
                @V_QTVOLUITEMSO,       @V_AUTOFORN_IDMOTIVPRESC, 'A', @V_AUTOFORN_CDCENTITMAP,
                @V_AUTOFORN_NRCOLEITMAP, @V_AUTOFORN_CDMARCA, @V_AUTOFORN_CDREGITMAP,
                @V_AUTOFORN_CDFORNECED, @V_AUTOFORN_CDPRODUTO, @V_AUTOFORN_NRLISTAITMAP);

            SET @V_NRPEDIDOCOL = NULL;
            SELECT @V_NRPEDIDOCOL = MAX(NRPEDIDOCOL)
            FROM ITEMCOLE
            WHERE ITEMCOLE.CDFILIAL    = @V_AUTOFORN_CDCENTITMAP
              AND ITEMCOLE.NRCOLEPRECO = @V_AUTOFORN_NRCOLEITMAP
              AND ITEMCOLE.CDMARCA     = @V_AUTOFORN_CDMARCA
              AND ITEMCOLE.CDREGIAO    = @V_AUTOFORN_CDREGITMAP
              AND ITEMCOLE.CDFORNECED  = @V_AUTOFORN_CDFORNECED
              AND ITEMCOLE.CDPRODUTO   = @V_AUTOFORN_CDPRODUTO;

            IF @V_NRPEDIDOCOL IS NOT NULL BEGIN
               IF @V_IDUTQTDISPGERAL = 'S' AND @V_AUTOFORN_IDUTQTDISPFORN = 'S' BEGIN
                  UPDATE PRMARCPEDCOL
                  SET QTDISPPRODMARC = CASE QTDISPPRODMARC - @V_QTPROGENTAF
                                          WHEN ABS(QTDISPPRODMARC - @V_QTPROGENTAF) THEN QTDISPPRODMARC - @V_QTPROGENTAF
                                          ELSE 0
                                       END
                  WHERE PRMARCPEDCOL.CDFILIAL       = @V_AUTOFORN_CDCENTITMAP
                    AND PRMARCPEDCOL.NRPEDIDOCOL    = @V_NRPEDIDOCOL
                    AND PRMARCPEDCOL.CDPRODUTO      = @V_AUTOFORN_CDPRODUTO
                    AND PRMARCPEDCOL.CDMARCA        = @V_AUTOFORN_CDMARCA
                    AND PRMARCPEDCOL.QTDISPPRODMARC IS NOT NULL;
               END;
            END;
         END
         ELSE BEGIN
            UPDATE ITEMAUTF
            SET QTPROGENTAF   = QTPROGENTAF + @V_QTPROGENTAF
            WHERE CDFILDEST   = @V_AUTOFORN_CDFILDEST                       AND
                  CDFILLANC   = @V_AUTOFORN_CDFILLANC                       AND
                  NRAUTOFORN  = @V_CODIGO                                   AND
                  CDPRODUTO   = ISNULL(@V_PRODUTOOL, @V_AUTOFORN_CDPRODUTO) AND
                  CDMARCA     = ISNULL(@V_MARCAITEM, @V_AUTOFORN_CDMARCA)   AND
                  DTPROGENTAF = @V_NEW_DTPROGENTAF;

            SET @V_NRPEDIDOCOL = NULL;
            SELECT @V_NRPEDIDOCOL = MAX(NRPEDIDOCOL)
            FROM ITEMCOLE
            WHERE ITEMCOLE.CDFILIAL    = @V_AUTOFORN_CDCENTITMAP
              AND ITEMCOLE.NRCOLEPRECO = @V_AUTOFORN_NRCOLEITMAP
              AND ITEMCOLE.CDMARCA     = @V_AUTOFORN_CDMARCA
              AND ITEMCOLE.CDREGIAO    = @V_AUTOFORN_CDREGITMAP
              AND ITEMCOLE.CDFORNECED  = @V_AUTOFORN_CDFORNECED
              AND ITEMCOLE.CDPRODUTO   = @V_AUTOFORN_CDPRODUTO;

            IF @V_NRPEDIDOCOL IS NOT NULL BEGIN
               IF @V_IDUTQTDISPGERAL = 'S' AND @V_AUTOFORN_IDUTQTDISPFORN = 'S' BEGIN
                  UPDATE PRMARCPEDCOL
                  SET QTDISPPRODMARC = CASE QTDISPPRODMARC - @V_QTPROGENTAF
                                          WHEN ABS(QTDISPPRODMARC - @V_QTPROGENTAF) THEN QTDISPPRODMARC - @V_QTPROGENTAF
                                          ELSE 0
                                       END
                  WHERE PRMARCPEDCOL.CDFILIAL       = @V_AUTOFORN_CDCENTITMAP
                    AND PRMARCPEDCOL.NRPEDIDOCOL    = @V_NRPEDIDOCOL
                    AND PRMARCPEDCOL.CDPRODUTO      = @V_AUTOFORN_CDPRODUTO
                    AND PRMARCPEDCOL.CDMARCA        = @V_AUTOFORN_CDMARCA
                    AND PRMARCPEDCOL.QTDISPPRODMARC IS NOT NULL;
               END;
            END;
         END;

         IF @V_AUTOFORN_DTPROGENTAF <> @V_DTENTRITMSOL BEGIN
            /* Solicitao de Compras da Entrega no antecipada */
            SET @V_NRSOLCOMP = NULL;
            SELECT
               @V_NRSOLCOMP = MAX(ITEMSOLI.NRSOLICMP + ITEMSOLI.CDFILLAN + ITEMSOLI.CDPRODUTO)
            FROM
               ITEMSOLI,
               PRODUTO PRODSOLI,
               PRODUTO
            WHERE
               ITEMSOLI.CDPRODUTO   = PRODSOLI.CDPRODUTO      AND
               ITEMSOLI.CDFILSOLI   = @V_AUTOFORN_CDFILDEST   AND
               ITEMSOLI.DTPROGENTR  = @V_AUTOFORN_DTPROGENTAF AND
               PRODUTO.CDPRODUTO    = @V_AUTOFORN_CDPRODUTO   AND
               PRODSOLI.CDPRODESTO  = PRODUTO.CDPRODESTO      AND
               ITEMSOLI.CDPRODUTO   = CASE @V_AUTOFORN_IDFUNCAOFILI
                                         WHEN 'O'
                                         THEN CASE @V_IDUTLPRCMPATIVO
                                                 WHEN 'S'
                                                 THEN ITEMSOLI.CDPRODUTO
                                                 ELSE @V_AUTOFORN_CDPRODUTO
                                              END
                                         ELSE ITEMSOLI.CDPRODUTO
                                      END;
            SET @V_ANTQTSOLIPROD = NULL;

            SELECT @V_ANTQTSOLIPROD = QTSOLIPROD
            FROM ITEMSOLI
            WHERE
               CDFILSOLI  = @V_AUTOFORN_CDFILDEST           AND
               CDFILLAN   = SUBSTRING(@V_NRSOLCOMP, 11, 4)  AND
               NRSOLICMP  = SUBSTRING(@V_NRSOLCOMP, 1, 10)  AND
               CDPRODUTO  = SUBSTRING(@V_NRSOLCOMP, 15, 10) AND
               DTPROGENTR = @V_AUTOFORN_DTPROGENTAF;

            SET @V_NRSOLCOMP = NULL;

            SELECT
                @V_NRSOLCOMP = MAX(ITEMSOLI.NRSOLICMP + ITEMSOLI.CDFILLAN + ITEMSOLI.CDPRODUTO)
            FROM
               ITEMSOLI,
               PRODUTO PRODSOLI,
               PRODUTO
            WHERE
               ITEMSOLI.CDPRODUTO   = PRODSOLI.CDPRODUTO     AND
               ITEMSOLI.CDFILSOLI   = @V_AUTOFORN_CDFILDEST  AND
               ITEMSOLI.DTPROGENTR  = @V_DTENTRITMSOL        AND
               PRODUTO.CDPRODUTO    = @V_AUTOFORN_CDPRODUTO  AND
               PRODSOLI.CDPRODESTO  = PRODUTO.CDPRODESTO     AND
               ITEMSOLI.CDPRODUTO   = CASE @V_AUTOFORN_IDFUNCAOFILI
                                         WHEN 'O'
                                         THEN CASE @V_IDUTLPRCMPATIVO
                                                 WHEN 'S'
                                                 THEN ITEMSOLI.CDPRODUTO
                                                 ELSE @V_AUTOFORN_CDPRODUTO
                                              END
                                         ELSE ITEMSOLI.CDPRODUTO
                                      END;

              /* Log de Alterao */
            INSERT INTO MOVOPSOL
               (CDFILSOLMOV, CDFILLANMOV, NRSOLIMOV,
                CDPRODUTO, DTENTROPER, DTOPERSOL,
                CDOPERADOR, QTANTOPER, QTDEPOPER,
                DSJUSTOPER)
            SELECT
               ITEMSOLI.CDFILSOLI, ITEMSOLI.CDFILLAN, ITEMSOLI.NRSOLICMP,
               ITEMSOLI.CDPRODUTO, @V_DTENTRITMSOL, GETDATE(),
               @P_CDOPERADOR, ITEMSOLI.QTSOLIPROD, ITEMSOLI.QTSOLIPROD + @V_ANTQTSOLIPROD,
               'Ef.AF -Entr. Antecipada de ' + CONVERT(VARCHAR,@V_AUTOFORN_DTPROGENTAF,103)
            FROM
               ITEMSOLI
            WHERE
               ITEMSOLI.CDFILSOLI  = @V_AUTOFORN_CDFILDEST           AND
               ITEMSOLI.CDFILLAN   = SUBSTRING(@V_NRSOLCOMP, 11, 4)  AND
               ITEMSOLI.NRSOLICMP  = SUBSTRING(@V_NRSOLCOMP, 1, 10)  AND
               ITEMSOLI.CDPRODUTO  = SUBSTRING(@V_NRSOLCOMP, 15, 10) AND
               ITEMSOLI.DTPROGENTR = @V_DTENTRITMSOL;

            SET @V_DTAUX = GETDATE();

            WHILE @V_DTAUX = GETDATE() BEGIN
               SET @V_DTAUX = @V_DTAUX;
            END;

            UPDATE ITEMSOLI
               SET QTSOLIPROD = QTSOLIPROD + @V_ANTQTSOLIPROD
               WHERE
                  CDFILSOLI  = @V_AUTOFORN_CDFILDEST           AND
                  CDFILLAN   = SUBSTRING(@V_NRSOLCOMP, 11, 4)  AND
                  NRSOLICMP  = SUBSTRING(@V_NRSOLCOMP, 1, 10)  AND
                  CDPRODUTO  = SUBSTRING(@V_NRSOLCOMP, 15, 10) AND
                  DTPROGENTR = @V_DTENTRITMSOL;
               SET @V_QTSOLIPROD = 0;

               /* Retirar quantidade da antiga solicitao */
               DECLARE C_ITEMSOLI_AF CURSOR FOR
               (SELECT
                   ITEMSOLI.CDFILSOLI,
                   ITEMSOLI.CDFILLAN,
                   ITEMSOLI.NRSOLICMP,
                   ITEMSOLI.CDPRODUTO,
                   ITEMSOLI.DTPROGENTR,
                   ITEMSOLI.QTSOLIPROD
                FROM
                   ITEMSOLI,
                   PRODUTO PRODSOLI,
                   PRODUTO
                WHERE
                   ITEMSOLI.CDPRODUTO   = PRODSOLI.CDPRODUTO      AND
                   ITEMSOLI.CDFILSOLI   = @V_AUTOFORN_CDFILDEST   AND
                   ITEMSOLI.DTPROGENTR  = @V_AUTOFORN_DTPROGENTAF AND
                   PRODUTO.CDPRODUTO    = @V_AUTOFORN_CDPRODUTO   AND
                   PRODSOLI.CDPRODESTO  = PRODUTO.CDPRODESTO      AND
                   ITEMSOLI.CDPRODUTO   = CASE @V_AUTOFORN_IDFUNCAOFILI
                                             WHEN 'O'
                                             THEN CASE @V_IDUTLPRCMPATIVO
                                                     WHEN 'S'
                                                     THEN ITEMSOLI.CDPRODUTO
                                                     ELSE @V_AUTOFORN_CDPRODUTO
                                                  END
                                             ELSE ITEMSOLI.CDPRODUTO
                                          END)

               OPEN C_ITEMSOLI_AF;
               FETCH NEXT FROM C_ITEMSOLI_AF INTO @V_ITEMSOLI_CDFILSOLI,
                                               @V_ITEMSOLI_CDFILLAN,
                                               @V_ITEMSOLI_NRSOLICMP,
                                               @V_ITEMSOLI_CDPRODUTO,
                                               @V_ITEMSOLI_DTPROGENTR,
                                               @V_ITEMSOLI_QTSOLIPROD;
               WHILE (@@FETCH_STATUS = 0) BEGIN
                  IF @V_QTSOLIPROD = 0 BEGIN
                     SET @V_QTSOLIPROD = @V_ANTQTSOLIPROD - @V_ITEMSOLI_QTSOLIPROD;
                  END ELSE BEGIN
                     SET @V_QTSOLIPROD = @V_QTSOLIPROD - @V_ITEMSOLI_QTSOLIPROD;
                  END;
                  IF @V_QTSOLIPROD >= 0 BEGIN
                     DELETE FROM ITEMSOLI
                     WHERE
                        CDFILSOLI  = @V_ITEMSOLI_CDFILSOLI  AND
                        CDFILLAN   = @V_ITEMSOLI_CDFILLAN   AND
                        NRSOLICMP  = @V_ITEMSOLI_NRSOLICMP  AND
                        CDPRODUTO  = @V_ITEMSOLI_CDPRODUTO  AND
                        DTPROGENTR = @V_ITEMSOLI_DTPROGENTR;
                        /* LOG DE ALTERAO */
                     INSERT INTO MOVOPSOL
                        (CDFILSOLMOV, CDFILLANMOV, NRSOLIMOV,
                         CDPRODUTO, DTENTROPER, DTOPERSOL,
                         CDOPERADOR, QTANTOPER, QTDEPOPER,
                         DSJUSTOPER)
                     VALUES
                        (@V_ITEMSOLI_CDFILSOLI, @V_ITEMSOLI_CDFILLAN, @V_ITEMSOLI_NRSOLICMP,
                         @V_ITEMSOLI_CDPRODUTO, @V_ITEMSOLI_DTPROGENTR, GETDATE(),
                         @P_CDOPERADOR, @V_ITEMSOLI_QTSOLIPROD, 0,
                         'EF.AF -ENTR. ANTECIPADA P/ ' + CONVERT(VARCHAR,@V_DTENTRITMSOL,103));
                     SET @V_DTAUX = GETDATE();
                     WHILE @V_DTAUX = GETDATE() BEGIN
                        SET @V_DTAUX = @V_DTAUX;
                     END;
                     IF @V_QTSOLIPROD = 0 BEGIN
                        BREAK;
                     END;
                  END ELSE BEGIN
                     IF @V_QTSOLIPROD < 0 BEGIN
                        UPDATE ITEMSOLI
                        SET
                           QTSOLIPROD = ABS(@V_QTSOLIPROD)
                        WHERE
                           CDFILSOLI  = @V_ITEMSOLI_CDFILSOLI  AND
                           CDFILLAN   = @V_ITEMSOLI_CDFILLAN   AND
                           NRSOLICMP  = @V_ITEMSOLI_NRSOLICMP  AND
                           CDPRODUTO  = @V_ITEMSOLI_CDPRODUTO  AND
                           DTPROGENTR = @V_ITEMSOLI_DTPROGENTR;
                        /* LOG DE ALTERAO */
                        INSERT INTO MOVOPSOL
                           (CDFILSOLMOV, CDFILLANMOV, NRSOLIMOV,
                            CDPRODUTO, DTENTROPER, DTOPERSOL,
                            CDOPERADOR, QTANTOPER, QTDEPOPER,
                            DSJUSTOPER)
                        VALUES
                           (@V_ITEMSOLI_CDFILSOLI, @V_ITEMSOLI_CDFILLAN, @V_ITEMSOLI_NRSOLICMP,
                            @V_ITEMSOLI_CDPRODUTO, @V_ITEMSOLI_DTPROGENTR, GETDATE(),
                            @P_CDOPERADOR,@V_ITEMSOLI_QTSOLIPROD, ABS(@V_QTSOLIPROD),
                            'EF.AF -ENTR. ANTECIPADA P/ '+ CONVERT(VARCHAR,@V_DTENTRITMSOL,103));
                        SET @V_DTAUX = GETDATE();
                        WHILE @V_DTAUX = GETDATE() BEGIN
                           SET @V_DTAUX = @V_DTAUX;
                        END;
                        BREAK;
                     END;
                  END;
               FETCH NEXT FROM C_ITEMSOLI_AF INTO @V_ITEMSOLI_CDFILSOLI,
                                               @V_ITEMSOLI_CDFILLAN,
                                               @V_ITEMSOLI_NRSOLICMP,
                                               @V_ITEMSOLI_CDPRODUTO,
                                               @V_ITEMSOLI_DTPROGENTR,
                                               @V_ITEMSOLI_QTSOLIPROD;
               END;
               CLOSE C_ITEMSOLI_AF;
               DEALLOCATE C_ITEMSOLI_AF;
         END;

         IF (@V_DSATUAL <> @V_DSANTERIOR) AND (NOT @V_DSANTERIOR IS NULL) BEGIN
            /* SE ALGUM PRODUTO FOR FRACIONADO, UPDATA A APURAO PARA HABILITAR O BOTO DE APURAR NOVAMENTE */
            IF @V_IDARREDCMPAMENOS = 'S' BEGIN
               SELECT @V_IDQTFRACIONADO = ISNULL(MAX('S'), 'N')
                 FROM AUTOFORNE A, ITEMAUTF I, FILIAL F
                WHERE I.CDFILDEST   = A.CDFILDEST
                  AND I.CDFILLANC   = A.CDFILLANC
                  AND I.NRAUTOFORN  = A.NRAUTOFORN
                  AND A.CDFILDEST   = F.CDFILIAL
                  AND A.NRSEQAPURAF = @P_NRSEQAPUR
                  AND CASE WHEN F.CDFILCENTCMP IS NULL THEN F.CDFILIAL ELSE F.CDFILCENTCMP END = @P_CDCENTCMP
                  AND FLOOR(I.QTPROGENTAF) <> I.QTPROGENTAF;

               IF @V_IDQTFRACIONADO = 'S' BEGIN
                  SET @V_CONTADOR = @V_CONTADOR + 1;
               END;
            END;

            -- FECHAMENTO_AF;
            -- GERA-PARCELAS

            SET @V_NRPARCITMAF = '00';

            DECLARE C_NRPARCITMAF CURSOR FOR
             SELECT DISTINCT ITEMAUTF.DTPROGENTAF
              FROM ITEMAUTF
             WHERE (ITEMAUTF.CDFILDEST  = @V_ANTCDFILDEST) AND
                   (ITEMAUTF.CDFILLANC  = @V_ANTCDFILLANC) AND
                   (ITEMAUTF.NRAUTOFORN = @V_ANTCODIGO)
              ORDER BY DTPROGENTAF
            OPEN C_NRPARCITMAF;
            FETCH NEXT FROM C_NRPARCITMAF INTO @V_DTPROGENTAF1
            WHILE (@@FETCH_STATUS = 0) BEGIN
               SET @V_NRPARCITMAF = RIGHT(REPLICATE('0', 2) + CONVERT(VARCHAR, CONVERT(DOUBLE PRECISION, @V_NRPARCITMAF) + 1), 2);
               UPDATE ITEMAUTF
               SET ITEMAUTF.NRPARCITMAF = @V_NRPARCITMAF,
                   ITEMAUTF.QTPROGENTAF = CASE @V_IDARREDCMPAMENOS
                                             WHEN 'S'
                                             THEN CASE ISNULL(FLOOR(ITEMAUTF.QTPROGENTAF), 1)
                                                     WHEN 0
                                                     THEN ITEMAUTF.QTPROGENTAF
                                                     ELSE ISNULL(FLOOR(ITEMAUTF.QTPROGENTAF), 1)
                                                  END
                                             ELSE ITEMAUTF.QTPROGENTAF
                                          END
               WHERE
                  (ITEMAUTF.CDFILDEST    = @V_ANTCDFILDEST) AND
                  (ITEMAUTF.CDFILLANC    = @V_ANTCDFILLANC) AND
                  (ITEMAUTF.NRAUTOFORN   = @V_ANTCODIGO)   AND
                  (ITEMAUTF.DTPROGENTAF  = @V_DTPROGENTAF1);
               FETCH NEXT FROM C_NRPARCITMAF INTO @V_DTPROGENTAF1
            END;
            CLOSE C_NRPARCITMAF;
            DEALLOCATE C_NRPARCITMAF;

            SET @V_CDINSCESTA = NULL;

            SELECT @V_CDINSCESTA = MIN(CDINSCESTA)
            FROM INSCRESTAD
            WHERE (CDEMPRESA = @V_ANTCDEMPRESA);

            SET @V_DTPROGENTAF = NULL;

            SELECT @V_DTPROGENTAF = MIN(DTPROGENTAF)
            FROM ITEMAUTF
            WHERE (CDFILDEST  = @V_ANTCDFILDEST)  AND
                  (CDFILLANC  = @V_ANTCDFILLANC)  AND
                  (NRAUTOFORN = @V_ANTCODIGO);
            EXEC IMPOSTO_ITEMAF @V_ANTCDEMPRESA,
                                @V_CDINSCESTA,
                                @V_ANTCDFORNECED,
                                @V_ANTCDFILDEST,
                                @V_ANTCDFILLANC,
                                @V_ANTCODIGO,
                                @V_DTPROGENTAF;
            -- qryValor_AF

            SET @V_VRPRODUTO  = NULL;
            SET @V_VRDESCONTO = NULL;

            SELECT
               @V_VRPRODUTO  = SUM(ITEMAUTF.QTPROGENTAF * ITEMAUTF.VRPREUNIAF),
               @V_VRDESCONTO = SUM((ITEMAUTF.QTPROGENTAF * ITEMAUTF.VRPREUNIAF * ISNULL(ITEMAUTF.VRPERDESAF, 0)) / 100)
            FROM
               ITEMAUTF
            WHERE
               (ITEMAUTF.CDFILDEST  = @V_ANTCDFILDEST) AND
               (ITEMAUTF.CDFILLANC  = @V_ANTCDFILLANC) AND
               (ITEMAUTF.NRAUTOFORN = @V_ANTCODIGO);

            SET @V_VRIMPOSTO = 0;

            SELECT
               @V_VRIMPOSTO = ISNULL(SUM(IMPITMAF.VRADIMPAF), 0)
            FROM
               IMPITMAF,
               ITEMAUTF,
               IMPOSTO
            WHERE
               (IMPITMAF.CDFILDEST   = @V_ANTCDFILDEST)      AND
               (IMPITMAF.CDFILLANC   = @V_ANTCDFILLANC)      AND
               (IMPITMAF.NRAUTOFORN  = @V_ANTCODIGO)         AND
               (IMPITMAF.CDFILDEST   = ITEMAUTF.CDFILDEST)   AND
               (IMPITMAF.CDFILLANC   = ITEMAUTF.CDFILLANC)   AND
               (IMPITMAF.NRAUTOFORN  = ITEMAUTF.NRAUTOFORN)  AND
               (IMPITMAF.CDPRODUTO   = ITEMAUTF.CDPRODUTO)   AND
               (IMPITMAF.CDMARCA     = ITEMAUTF.CDMARCA)     AND
               (IMPITMAF.DTPROGENTAF = ITEMAUTF.DTPROGENTAF) AND
               (IMPITMAF.CDIMPOSTO   = IMPOSTO.CDIMPOSTO)    AND
                ISNULL(IMPOSTO.IDACRPRODENTRNF, 'N') = 'N';

            UPDATE AUTOFORNE
            SET VRTOTALAF = @V_VRPRODUTO - @V_VRDESCONTO + @V_VRIMPOSTO
            WHERE
               (CDFILDEST   = @V_ANTCDFILDEST) AND
               (CDFILLANC   = @V_ANTCDFILLANC) AND
               (NRAUTOFORN  = @V_ANTCODIGO);
         END;

         -- qryLimite_AF
         -- qryConsAF

         IF @V_AUTOFORN_DTENTRAPUT IS NULL BEGIN
            SET @V_DSANTERIOR = @V_AUTOFORN_CDFILDEST    + @V_AUTOFORN_CDFILLANC    +
                                @V_AUTOFORN_CDFORNECED   + ISNULL(@V_AUTOFORN_IDTPFORPGTAP, '') +
                                ISNULL(@V_AUTOFORN_CDTIPCOB, '')     + '' +
                                @V_AUTOFORN_IDTIPOEMITAP + @V_EMPRESA    +
                                ISNULL(@V_AUTOFORN_IDTIPOFRETAP, '') + ISNULL(@V_AUTOFORN_CDFORMPGTO, '')   +
                                ISNULL(CONVERT(VARCHAR, @V_AUTOFORN_NRPARCPGTOAP), '') + ISNULL(CONVERT(VARCHAR, @V_AUTOFORN_NRDIAPGFIXAF), '') +
                                ISNULL(@V_AUTOFORN_IDUTDIAPGTAF, '') + ISNULL(CONVERT(VARCHAR, @V_AUTOFORN_DSPZOPGTCOAP), '') +
                                @V_AUTOFORN_CONC_KEY;
         END
         ELSE BEGIN
            SET @V_DSANTERIOR = @V_AUTOFORN_CDFILDEST    + @V_AUTOFORN_CDFILLANC    +
                                @V_AUTOFORN_CDFORNECED   + ISNULL(@V_AUTOFORN_IDTPFORPGTAP, '') +
                                ISNULL(@V_AUTOFORN_CDTIPCOB, '')     + CONVERT(VARCHAR,@V_AUTOFORN_DTENTRAPUT,103) +
                                @V_AUTOFORN_IDTIPOEMITAP + @V_EMPRESA    +
                                ISNULL(@V_AUTOFORN_IDTIPOFRETAP, '') + ISNULL(@V_AUTOFORN_CDFORMPGTO, '')   +
                                ISNULL(CONVERT(VARCHAR, @V_AUTOFORN_NRPARCPGTOAP), '') + ISNULL(CONVERT(VARCHAR, @V_AUTOFORN_NRDIAPGFIXAF), '') +
                                ISNULL(@V_AUTOFORN_IDUTDIAPGTAF, '') + ISNULL(CONVERT(VARCHAR, @V_AUTOFORN_DSPZOPGTCOAP), '') +
                                @V_AUTOFORN_CONC_KEY;
         END;

         --  DBMS_OUTPUT.PUT_LINE('CONC_KEY = '+ @V_AUTOFORN_CONC_KEY);

         SET @V_ANTCODIGO       = @V_CODIGO;
         SET @V_ANTCDFILDEST    = @V_AUTOFORN_CDFILDEST;
         SET @V_ANTCDFILLANC    = @V_AUTOFORN_CDFILLANC;
         SET @V_ANTCDFORNECED   = @V_AUTOFORN_CDFORNECED;
         SET @V_ANTIDTPFORPGTAF = @V_AUTOFORN_IDTPFORPGTAP;
         SET @V_ANTCDTIPCOB     = @V_AUTOFORN_CDTIPCOB;
         SET @V_ANTIDTIPOEMITAF = @V_AUTOFORN_IDTIPOEMITAP;
         SET @V_ANTCDEMPRESA    = @V_EMPRESA;
         SET @V_ANTIDTIPOFRETAF = @V_AUTOFORN_IDTIPOFRETAP;
         SET @V_ANTCDFORMPGTO   = @V_AUTOFORN_CDFORMPGTO;
         SET @V_ANTNRPARCPGTOAF = @V_AUTOFORN_NRPARCPGTOAP;
         SET @V_ANTNRDIAPGFIXAF = @V_AUTOFORN_NRDIAPGFIXAF;
         SET @V_ANTIDUTDIAPGTAF = @V_AUTOFORN_IDUTDIAPGTAF;
         SET @V_ANTDSPZOPGTCONC = @V_AUTOFORN_DSPZOPGTCOAP;
         SET @V_ANTCONC_KEY     = @V_AUTOFORN_CONC_KEY;
         FETCH NEXT FROM C_AUTOFORN INTO @V_AUTOFORN_DTENTRAPUT,
                                         @V_AUTOFORN_CDMARCA,
                                         @V_AUTOFORN_CDSEGMARCA,
                                         @V_AUTOFORN_CDFILDEST,
                                         @V_AUTOFORN_IDFUNCAOFILI,
                                         @V_AUTOFORN_CDFILLANC,
                                         @V_AUTOFORN_CDFORNECED,
                                         @V_AUTOFORN_IDTPFORPGTAP,
                                         @V_AUTOFORN_CDTIPCOB,
                                         @V_AUTOFORN_DTPROGENTAF,
                                         @V_AUTOFORN_QTPROGENTAF,
                                         @V_AUTOFORN_VRPREUNIAF,
                                         @V_AUTOFORN_VRPERDESAF,
                                         @V_AUTOFORN_CDPRODUTO,
                                         @V_AUTOFORN_IDTIPOEMITAP,
                                         @V_AUTOFORN_CDEMPRESA,
                                         @V_AUTOFORN_IDTIPOFRETAP,
                                         @V_AUTOFORN_CDFORMPGTO,
                                         @V_AUTOFORN_NRPARCPGTOAP,
                                         @V_AUTOFORN_NRDIAPGFIXAF,
                                         @V_AUTOFORN_IDUTDIAPGTAF,
                                         @V_AUTOFORN_DSPZOPGTCOAP,
                                         @V_AUTOFORN_CONC_KEY,
                                         @V_AUTOFORN_IDAFOPERLOG,
                                         @V_AUTOFORN_IDPRODWEB,
                                         @V_AUTOFORN_CDCENTITMAP,
                                         @V_AUTOFORN_CDREGITMAP,
                                         @V_AUTOFORN_IDMOTIVPRESC,
                                         @V_AUTOFORN_NRCOLEITMAP,
                                         @V_AUTOFORN_NRLISTAITMAP,
                                         @V_AUTOFORN_CDARVPROD,
                                         @V_AUTOFORN_IDUTQTDISPFORN;
      END;
   END;
   CLOSE C_AUTOFORN;
   DEALLOCATE C_AUTOFORN;

   /* SE ALGUM PRODUTO FOR FRACIONADO, UPDATA A APURAO PARA HABILITAR O BOTO DE APURAR NOVAMENTE */
   IF @V_IDARREDCMPAMENOS = 'S' BEGIN
      SELECT @V_IDQTFRACIONADO = ISNULL(MAX('S'), 'N')
        FROM AUTOFORNE A, ITEMAUTF I, FILIAL F
       WHERE I.CDFILDEST   = A.CDFILDEST
         AND I.CDFILLANC   = A.CDFILLANC
         AND I.NRAUTOFORN  = A.NRAUTOFORN
         AND A.CDFILDEST   = F.CDFILIAL
         AND A.NRSEQAPURAF = @P_NRSEQAPUR
         AND CASE WHEN F.CDFILCENTCMP IS NULL THEN F.CDFILIAL ELSE F.CDFILCENTCMP END = @P_CDCENTCMP
         AND FLOOR(I.QTPROGENTAF) <> I.QTPROGENTAF;

      IF @V_IDQTFRACIONADO = 'S' BEGIN
         SET @V_CONTADOR = @V_CONTADOR + 1;
      END;
   END;

   -- FECHAMENTO_AF;
   -- GERA-PARCELAS

   SET @V_NRPARCITMAF = '00';

   DECLARE C_NRPARCITMAF CURSOR FOR
    SELECT DISTINCT ITEMAUTF.DTPROGENTAF
     FROM ITEMAUTF
    WHERE (ITEMAUTF.CDFILDEST  = @V_ANTCDFILDEST) AND
          (ITEMAUTF.CDFILLANC  = @V_ANTCDFILLANC) AND
          (ITEMAUTF.NRAUTOFORN = @V_ANTCODIGO)
     ORDER BY DTPROGENTAF
   OPEN C_NRPARCITMAF;
   FETCH NEXT FROM C_NRPARCITMAF INTO @V_DTPROGENTAF1
   WHILE (@@FETCH_STATUS = 0) BEGIN
      SET @V_NRPARCITMAF = RIGHT(REPLICATE('0', 2) + CONVERT(VARCHAR, CONVERT(DOUBLE PRECISION, @V_NRPARCITMAF) + 1), 2);
      UPDATE ITEMAUTF
      SET ITEMAUTF.NRPARCITMAF = @V_NRPARCITMAF,
          ITEMAUTF.QTPROGENTAF = CASE @V_IDARREDCMPAMENOS
                                    WHEN 'S'
                                    THEN CASE ISNULL(FLOOR(ITEMAUTF.QTPROGENTAF), 1)
                                            WHEN 0
                                            THEN ITEMAUTF.QTPROGENTAF
                                            ELSE ISNULL(FLOOR(ITEMAUTF.QTPROGENTAF), 1)
                                         END
                                    ELSE ITEMAUTF.QTPROGENTAF
                                 END
      WHERE
         (ITEMAUTF.CDFILDEST   = @V_ANTCDFILDEST) AND
         (ITEMAUTF.CDFILLANC   = @V_ANTCDFILLANC) AND
         (ITEMAUTF.NRAUTOFORN  = @V_ANTCODIGO)    AND
         (ITEMAUTF.DTPROGENTAF = @V_DTPROGENTAF1);
      FETCH NEXT FROM C_NRPARCITMAF INTO @V_DTPROGENTAF1
   END;
   CLOSE C_NRPARCITMAF;
   DEALLOCATE C_NRPARCITMAF;

   SET @V_CDINSCESTA = NULL;

   SELECT @V_CDINSCESTA = MIN(CDINSCESTA)
     FROM INSCRESTAD
    WHERE (CDEMPRESA = @V_ANTCDEMPRESA);

   SET @V_DTPROGENTAF = NULL;
   SELECT @V_DTPROGENTAF = MIN(DTPROGENTAF)
   FROM ITEMAUTF
   WHERE (CDFILDEST  = @V_ANTCDFILDEST)  AND
         (CDFILLANC  = @V_ANTCDFILLANC)  AND
         (NRAUTOFORN = @V_ANTCODIGO);
   EXEC IMPOSTO_ITEMAF @V_ANTCDEMPRESA,
                       @V_CDINSCESTA,
                       @V_ANTCDFORNECED,
                       @V_ANTCDFILDEST,
                       @V_ANTCDFILLANC,
                       @V_ANTCODIGO,
                       @V_DTPROGENTAF;

   -- qryValor_AF

   SET @V_VRPRODUTO  = NULL;
   SET @V_VRDESCONTO = NULL;

   SELECT
      @V_VRPRODUTO  = SUM(ITEMAUTF.QTPROGENTAF * ITEMAUTF.VRPREUNIAF),
      @V_VRDESCONTO = SUM((ITEMAUTF.QTPROGENTAF * ITEMAUTF.VRPREUNIAF * ISNULL(ITEMAUTF.VRPERDESAF, 0)) / 100)
   FROM
      ITEMAUTF
   WHERE
      (ITEMAUTF.CDFILDEST  = @V_ANTCDFILDEST) AND
      (ITEMAUTF.CDFILLANC  = @V_ANTCDFILLANC) AND
      (ITEMAUTF.NRAUTOFORN = @V_ANTCODIGO);

   SET @V_VRIMPOSTO = 0;

   SELECT
      @V_VRIMPOSTO = ISNULL(SUM(IMPITMAF.VRADIMPAF), 0)
   FROM
      IMPITMAF,
      ITEMAUTF,
      IMPOSTO
   WHERE
      (IMPITMAF.CDFILDEST   = @V_ANTCDFILDEST)      AND
      (IMPITMAF.CDFILLANC   = @V_ANTCDFILLANC)      AND
      (IMPITMAF.NRAUTOFORN  = @V_ANTCODIGO)         AND
      (IMPITMAF.CDFILDEST   = ITEMAUTF.CDFILDEST)   AND
      (IMPITMAF.CDFILLANC   = ITEMAUTF.CDFILLANC)   AND
      (IMPITMAF.NRAUTOFORN  = ITEMAUTF.NRAUTOFORN)  AND
      (IMPITMAF.CDPRODUTO   = ITEMAUTF.CDPRODUTO)   AND
      (IMPITMAF.CDMARCA     = ITEMAUTF.CDMARCA)     AND
      (IMPITMAF.DTPROGENTAF = ITEMAUTF.DTPROGENTAF) AND
      (IMPITMAF.CDIMPOSTO   = IMPOSTO.CDIMPOSTO)    AND
       ISNULL(IMPOSTO.IDACRPRODENTRNF, 'N') = 'N';

   UPDATE AUTOFORNE
   SET VRTOTALAF = @V_VRPRODUTO - @V_VRDESCONTO + @V_VRIMPOSTO
   WHERE
      (CDFILDEST   = @V_ANTCDFILDEST) AND
      (CDFILLANC   = @V_ANTCDFILLANC) AND
      (NRAUTOFORN  = @V_ANTCODIGO);

   /* SE ALGUM PRODUTO FOR FRACIONADO, UPDATA A APURAO PARA HABILITAR O BOTO DE APURAR NOVAMENTE */
   IF @V_IDARREDCMPAMENOS = 'S' BEGIN
      IF @V_CONTADOR = 0 BEGIN
         UPDATE APURPRECO
            SET IDQTFRACIONADO = 'N'
          WHERE APURPRECO.CDFILCENTCMP = @P_CDCENTCMP
            AND APURPRECO.NRAPURPREC   = @P_NRSEQAPUR;
      END
      ELSE BEGIN
         UPDATE APURPRECO
            SET IDQTFRACIONADO = 'S'
          WHERE APURPRECO.CDFILCENTCMP = @P_CDCENTCMP
            AND APURPRECO.NRAPURPREC   = @P_NRSEQAPUR;
      END;
   END;

   /* - Operador Logstico
   Gera AF Consolidante  */

   IF @V_IDUTILCONSSOLIOL = 'N' BEGIN
      SET @V_REGANTERIOR   = ' ';
      SET @V_ANTCDFILDEST  = ' ';
      SET @V_ANTCODIGO     = ' ';
      SET @V_ANTCDEMPRESA  = ' ';
      SET @V_ANTCDFORNECED = ' ';
      SET @V_SUMPERCPZO    = 0;
      SET @V_ITEMAUTF_ANTERIOR = ' ';
      DECLARE C_OPLOG CURSOR FOR
         SELECT DISTINCT
            PARAMPRODSUP.CDFILIOPELOG,
            AUTOFORNE.CDFORNECED,
            AUTOFORNE.CDEMPRESA,
            AUTOFORNE.IDTPFORPGTAF,
            AUTOFORNE.CDTIPCOB,
            AUTOFORNE.IDTIPOFRETAF,
            AUTOFORNE.CDFORMPGTO,
            AUTOFORNE.NRPARCPGTOAF,
            AUTOFORNE.NRDIAPGFIXAF,
            AUTOFORNE.IDUTDIAPGTAF,
            AUTOFORNE.IDTIPOEMITAF,
            AUTOFORNE.IDAFPRODWEB,
            PRAZOPGTAF.NRDIASPGTOAF,
            PRAZOPGTAF.VRPERCPGTOAF,
            AUTOFORNE.NRSEQAPURAF,
            AUTOFORNE.CDFILDEST,
            AUTOFORNE.NRAUTOFORN
         FROM
           PARAMPRODSUP,
           ITEMAUTF,
           AUTOFORNE LEFT JOIN PRAZOPGTAF
                          ON AUTOFORNE.CDFILDEST  = PRAZOPGTAF.CDFILDEST  AND
                             AUTOFORNE.CDFILLANC  = PRAZOPGTAF.CDFILLANC  AND
                             AUTOFORNE.NRAUTOFORN = PRAZOPGTAF.NRAUTOFORN
         WHERE
           AUTOFORNE.IDAFOPERLOG   = '2'                 AND
           AUTOFORNE.NRSEQAPURAF  = @P_NRSEQAPUR          AND
           ITEMAUTF.CDFILDEST     = AUTOFORNE.CDFILDEST  AND
           ITEMAUTF.CDFILLANC     = AUTOFORNE.CDFILLANC  AND
           ITEMAUTF.NRAUTOFORN    = AUTOFORNE.NRAUTOFORN AND
           PARAMPRODSUP.CDFILIAL  = ITEMAUTF.CDFILDEST   AND
           PARAMPRODSUP.CDPRODUTO = ITEMAUTF.CDPRODUTO   AND
           PARAMPRODSUP.CDFILIOPELOG IS NOT NULL
         ORDER BY
           PARAMPRODSUP.CDFILIOPELOG,
           AUTOFORNE.CDFORNECED,
           AUTOFORNE.CDEMPRESA,
           AUTOFORNE.IDTPFORPGTAF,
           AUTOFORNE.CDTIPCOB,
           AUTOFORNE.IDTIPOFRETAF,
           AUTOFORNE.CDFORMPGTO,
           AUTOFORNE.NRPARCPGTOAF,
           AUTOFORNE.NRDIAPGFIXAF,
           AUTOFORNE.IDUTDIAPGTAF,
           AUTOFORNE.IDTIPOEMITAF,
           AUTOFORNE.IDAFPRODWEB,
           AUTOFORNE.CDFILDEST,
           AUTOFORNE.NRAUTOFORN;
      OPEN C_OPLOG;
      FETCH NEXT FROM C_OPLOG INTO @V_OPLOG_CDFILIOPELOG,
                                   @V_OPLOG_CDFORNECED,
                                   @V_OPLOG_CDEMPRESA,
                                   @V_OPLOG_IDTPFORPGTAF,
                                   @V_OPLOG_CDTIPCOB,
                                   @V_OPLOG_IDTIPOFRETAF,
                                   @V_OPLOG_CDFORMPGTO,
                                   @V_OPLOG_NRPARCPGTOAF,
                                   @V_OPLOG_NRDIAPGFIXAF,
                                   @V_OPLOG_IDUTDIAPGTAF,
                                   @V_OPLOG_IDTIPOEMITAF,
                                   @V_OPLOG_IDAFPRODWEB,
                                   @V_OPLOG_NRDIASPGTOAF,
                                   @V_OPLOG_VRPERCPGTOAF,
                                   @V_OPLOG_NRSEQAPURAF,
                                   @V_OPLOG_CDFILDEST,
                                   @V_OPLOG_NRAUTOFORN;
      WHILE (@@FETCH_STATUS = 0) BEGIN
        SET @V_SUMPERCPZO = @V_SUMPERCPZO + ISNULL(@V_OPLOG_VRPERCPGTOAF,0);
        IF (@V_REGANTERIOR <> ISNULL(@V_OPLOG_CDFILIOPELOG, ' ') +
                              ISNULL(@V_OPLOG_CDFORNECED, ' ')   +
                              ISNULL(@V_OPLOG_CDEMPRESA, ' ')    +
                              ISNULL(@V_OPLOG_IDTPFORPGTAF, ' ') +
                              ISNULL(@V_OPLOG_CDTIPCOB, ' ')     +
                              ISNULL(@V_OPLOG_IDTIPOFRETAF, ' ') +
                              ISNULL(@V_OPLOG_CDFORMPGTO, ' ')   +
                              ISNULL(CONVERT(VARCHAR, @V_OPLOG_NRPARCPGTOAF), '') +
                              ISNULL(CONVERT(VARCHAR, @V_OPLOG_NRDIAPGFIXAF), '') +
                              ISNULL(@V_OPLOG_IDUTDIAPGTAF, ' ') +
                              ISNULL(@V_OPLOG_IDTIPOEMITAF, ' ') +
                              ISNULL(@V_OPLOG_IDAFPRODWEB, ' ')) OR (@V_SUMPERCPZO > 100) BEGIN
         IF @V_ANTCODIGO <> ' ' BEGIN
            -- GERA-PARCELAS
            SET @V_NRPARCITMAF = '00';
            DECLARE C_NRPARCITMAF CURSOR FOR
             SELECT DISTINCT ITEMAUTF.DTPROGENTAF
              FROM ITEMAUTF
             WHERE (ITEMAUTF.CDFILDEST  = @V_ANTCDFILDEST) AND
                   (ITEMAUTF.CDFILLANC  = @V_ANTCDFILLANC) AND
                   (ITEMAUTF.NRAUTOFORN = @V_ANTCODIGO)
              ORDER BY DTPROGENTAF
            OPEN C_NRPARCITMAF;
            FETCH NEXT FROM C_NRPARCITMAF INTO @V_DTPROGENTAF1
            WHILE (@@FETCH_STATUS = 0) BEGIN
               SET @V_NRPARCITMAF = RIGHT(REPLICATE('0', 2) + CONVERT(VARCHAR, CONVERT(DOUBLE PRECISION, @V_NRPARCITMAF) + 1), 2);
               UPDATE ITEMAUTF
               SET ITEMAUTF.NRPARCITMAF = @V_NRPARCITMAF
               WHERE
                  (ITEMAUTF.CDFILDEST    = @V_ANTCDFILDEST) AND
                  (ITEMAUTF.CDFILLANC    = @V_ANTCDFILLANC) AND
                  (ITEMAUTF.NRAUTOFORN   = @V_ANTCODIGO)   AND
                  (ITEMAUTF.DTPROGENTAF  = @V_DTPROGENTAF1);
               FETCH NEXT FROM C_NRPARCITMAF INTO @V_DTPROGENTAF1
            END;
            CLOSE C_NRPARCITMAF;
            DEALLOCATE C_NRPARCITMAF;

            SET @V_CDINSCESTA = NULL;
            SELECT @V_CDINSCESTA = MIN(CDINSCESTA)
            FROM INSCRESTAD
            WHERE (CDEMPRESA = @V_ANTCDEMPRESA);
            SET @V_DTPROGENTAF = NULL;
            SELECT @V_DTPROGENTAF = MIN(DTPROGENTAF)
            FROM ITEMAUTF
            WHERE (CDFILDEST  = @V_ANTCDFILDEST)  AND
                  (CDFILLANC  = @V_ANTCDFILLANC)  AND
                  (NRAUTOFORN = @V_ANTCODIGO);
            EXEC IMPOSTO_ITEMAF @V_ANTCDEMPRESA,
                                @V_CDINSCESTA,
                                @V_ANTCDFORNECED,
                                @V_ANTCDFILDEST,
                                @P_CDFILLANC,
                                @V_ANTCODIGO,
                                @V_DTPROGENTAF ;
            -- qryValor_AF
            SET @V_VRPRODUTO  = NULL;
            SET @V_VRDESCONTO = NULL;
            SELECT
               @V_VRPRODUTO  = SUM(ITEMAUTF.QTPROGENTAF * ITEMAUTF.VRPREUNIAF),
               @V_VRDESCONTO = SUM((ITEMAUTF.QTPROGENTAF * ITEMAUTF.VRPREUNIAF * ISNULL(ITEMAUTF.VRPERDESAF, 0)) / 100)
            FROM
               ITEMAUTF
            WHERE
               (ITEMAUTF.CDFILDEST  = @V_ANTCDFILDEST) AND
               (ITEMAUTF.CDFILLANC  = @V_ANTCDFILLANC) AND
               (ITEMAUTF.NRAUTOFORN = @V_ANTCODIGO);
            SET @V_VRIMPOSTO = 0;
            SELECT
               @V_VRIMPOSTO = ISNULL(SUM(IMPITMAF.VRADIMPAF), 0)
            FROM
               IMPITMAF,
               ITEMAUTF,
               IMPOSTO
            WHERE
               (IMPITMAF.CDFILDEST   = @V_ANTCDFILDEST)       AND
               (IMPITMAF.CDFILLANC   = @V_ANTCDFILLANC)       AND
               (IMPITMAF.NRAUTOFORN  = @V_ANTCODIGO)          AND
               (IMPITMAF.CDFILDEST   = ITEMAUTF.CDFILDEST)    AND
               (IMPITMAF.CDFILLANC   = ITEMAUTF.CDFILLANC)    AND
               (IMPITMAF.NRAUTOFORN  = ITEMAUTF.NRAUTOFORN)   AND
               (IMPITMAF.CDPRODUTO   = ITEMAUTF.CDPRODUTO)    AND
               (IMPITMAF.CDMARCA     = ITEMAUTF.CDMARCA)      AND
               (IMPITMAF.DTPROGENTAF = ITEMAUTF.DTPROGENTAF)  AND
               (IMPITMAF.CDIMPOSTO   = IMPOSTO.CDIMPOSTO)     AND
                ISNULL(IMPOSTO.IDACRPRODENTRNF, 'N') = 'N';
            UPDATE AUTOFORNE
            SET VRTOTALAF = @V_VRPRODUTO - @V_VRDESCONTO + @V_VRIMPOSTO
            WHERE
               (CDFILDEST   = @V_ANTCDFILDEST) AND
               (CDFILLANC   = @V_ANTCDFILLANC) AND
               (NRAUTOFORN  = @V_ANTCODIGO);
          END;
          SET @V_SUMPERCPZO  = ISNULL(@V_OPLOG_VRPERCPGTOAF,0);
          SET @V_REGANTERIOR = ISNULL(@V_OPLOG_CDFILIOPELOG, ' ') +
                               ISNULL(@V_OPLOG_CDFORNECED, ' ')   +
                               ISNULL(@V_OPLOG_CDEMPRESA, ' ')    +
                               ISNULL(@V_OPLOG_IDTPFORPGTAF, ' ') +
                               ISNULL(@V_OPLOG_CDTIPCOB, ' ')     +
                               ISNULL(@V_OPLOG_IDTIPOFRETAF, ' ') +
                               ISNULL(@V_OPLOG_CDFORMPGTO, ' ')   +
                               ISNULL(CONVERT(VARCHAR, @V_OPLOG_NRPARCPGTOAF), '') +
                               ISNULL(CONVERT(VARCHAR, @V_OPLOG_NRDIAPGFIXAF), '') +
                               ISNULL(@V_OPLOG_IDUTDIAPGTAF, ' ') +
                               ISNULL(@V_OPLOG_IDTIPOEMITAF, ' ') +
                               ISNULL(@V_OPLOG_IDAFPRODWEB, ' ');
          SET @V_AUX = 'AUTOFORNE';
          EXEC NOVO_CODIGO @V_AUX, @P_SEQUENCIAL = @V_NOVOCODIGO OUTPUT, @P_QTDE = 1;
          SET @V_NOVOCODIGO = SUBSTRING(@V_NOVOCODIGO, 11, 10);
          SET @V_ANTCDFILDEST  = @V_OPLOG_CDFILIOPELOG;
          SET @V_ANTCODIGO     = @V_NOVOCODIGO;
          SET @V_ANTCDEMPRESA  = @V_OPLOG_CDEMPRESA;
          SET @V_ANTCDFORNECED = @V_OPLOG_CDFORNECED;
          INSERT INTO AUTOFORNE
           (CDFILDEST,    CDFILLANC,    NRAUTOFORN,   CDOPERADOR,   DTAUTOFORN,
            IDTPFORPGTAF, IDTIPOEMITAF, IDTIPOFRETAF, NRPARCPGTOAF, NRDIAPGFIXAF,
            IDUTDIAPGTAF, CDTIPCOB,     CDEMPRESA,    CDFORMPGTO,   CDFORNECED,
            NRSEQAPURAF,  IDAFPRODWEB,  IDAFOPERLOG,  IDTIPOLANCAF, IDBAIXAAF, IDAFCONS, DSCONCKEYAF,
            IDAUTOFORNEX)
          VALUES
           (@V_OPLOG_CDFILIOPELOG, @P_CDFILLANC, @V_NOVOCODIGO, @P_CDOPERADOR,
            @P_DTAUTOFORN,         @V_OPLOG_IDTPFORPGTAF, @V_OPLOG_IDTIPOEMITAF,
            @V_OPLOG_IDTIPOFRETAF, @V_OPLOG_NRPARCPGTOAF, @V_OPLOG_NRDIAPGFIXAF,
            @V_OPLOG_IDUTDIAPGTAF, @V_OPLOG_CDTIPCOB,     @V_OPLOG_CDEMPRESA,
            @V_OPLOG_CDFORMPGTO,   @V_OPLOG_CDFORNECED,   @V_OPLOG_NRSEQAPURAF,
            @V_OPLOG_IDAFPRODWEB,  '1', 'A', '6', 'N',    @V_AUTOFORN_CONC_KEY,
            @V_EXTRA);

          IF @V_OPLOG_NRDIASPGTOAF IS NOT NULL BEGIN
            INSERT INTO PRAZOPGTAF
             (CDFILDEST, CDFILLANC, NRAUTOFORN,  NRDIASPGTOAF, VRPERCPGTOAF)
            VALUES
             (@V_OPLOG_CDFILIOPELOG, @P_CDFILLANC, @V_NOVOCODIGO,
              @V_OPLOG_NRDIASPGTOAF, @V_OPLOG_VRPERCPGTOAF);
          END;
        END;
         
        UPDATE AUTOFORNE
        SET CDFILDESTCON = @V_OPLOG_CDFILIOPELOG,
            CDFILLANCCON = @P_CDFILLANC,
            NRAUTOFORCON = @V_NOVOCODIGO
        WHERE
           CDFILDEST  = @V_OPLOG_CDFILDEST AND
           CDFILLANC  = @P_CDFILLANC AND
           NRAUTOFORN = @V_OPLOG_NRAUTOFORN;
        DECLARE C_ITOPLOG CURSOR FOR
          SELECT
             CDMARCA,    CDPRODUTO,   DTPROGENTAF,
             CDSEGMARCA, VRPREUNIAF,  VRPERDESAF,
             TXOBSITMAF, VRDESCITMAF, QTPROGENTAF
           FROM
             ITEMAUTF
           WHERE
             CDFILDEST  = @V_OPLOG_CDFILDEST  AND
             CDFILLANC  = @P_CDFILLANC  AND
             NRAUTOFORN = @V_OPLOG_NRAUTOFORN
        OPEN C_ITOPLOG;
        FETCH NEXT FROM C_ITOPLOG INTO @V_ITOPLOG_CDMARCA,
                                       @V_ITOPLOG_CDPRODUTO,
                                       @V_ITOPLOG_DTPROGENTAF,
                                       @V_ITOPLOG_CDSEGMARCA,
                                       @V_ITOPLOG_VRPREUNIAF,
                                       @V_ITOPLOG_VRPERDESAF,
                                       @V_ITOPLOG_TXOBSITMAF,
                                       @V_ITOPLOG_VRDESCITMAF,
                                       @V_ITOPLOG_QTPROGENTAF;

        WHILE (@@FETCH_STATUS = 0) BEGIN
           SET @V_QTPROGENTAF = @V_ITOPLOG_QTPROGENTAF;

           IF @V_IDUTEMPENHAF = 'S' BEGIN
              SET @V_VRARREDEMPE = 0;

              SELECT
                 @V_VRARREDEMPE = ISNULL(MAX(VRARREDEMPMAR), 0)
              FROM
                 MARCPROD
              WHERE
                 (CDMARCA   = @V_AUTOFORN_CDMARCA) AND
                 (CDPRODUTO IN (SELECT
                                   P.CDPRODUTO
                                FROM
                                   PRODUTO P
                                WHERE
                                   P.CDPRODUTO = MARCPROD.CDPRODUTO AND
                                   @V_AUTOFORN_CDARVPROD LIKE P.CDARVPROD + '%') );

              IF @V_VRARREDEMPE = 0 BEGIN
                 SELECT
                    @V_VRARREDEMPE = ISNULL(MAX(VRARREDEMPE), 0)
                 FROM
                    PRODFORNCOMP
                 WHERE
                    CDPRODCOMPL = @V_ITOPLOG_CDPRODUTO AND
                    CDFORNECED = @V_OPLOG_CDFORNECED;
              END;

              IF @V_VRARREDEMPE >0 BEGIN
                 IF (((CAST(@V_QTPROGENTAF AS DOUBLE PRECISION) / @V_VRARREDEMPE) - (ROUND(@V_QTPROGENTAF / @V_VRARREDEMPE, 0, 1))) <> 0) AND @V_VRARREDEMPE > 0
                 BEGIN
                    SET @V_QTPROGENTAF = CEILING(CAST(@V_QTPROGENTAF AS DOUBLE PRECISION) / @V_VRARREDEMPE) * @V_VRARREDEMPE;
                 END;
              END;
           END;
          IF (@V_ITEMAUTF_ANTERIOR <>  @V_OPLOG_CDFILDEST+@V_OPLOG_NRAUTOFORN) BEGIN
             SELECT
               @V_CONT = COUNT(*)
             FROM
               ITEMAUTF
             WHERE
               CDFILDEST   = @V_OPLOG_CDFILIOPELOG  AND
               CDFILLANC   = @P_CDFILLANC           AND
               NRAUTOFORN  = @V_NOVOCODIGO          AND
               CDPRODUTO   = @V_ITOPLOG_CDPRODUTO   AND
               CDMARCA     = @V_ITOPLOG_CDMARCA     AND
               DTPROGENTAF = @V_ITOPLOG_DTPROGENTAF;
      /*       raise_application_error(-20501, '@V_CONT ='+@V_CONT); */
             IF @V_CONT = 0 BEGIN
               SET @V_VRPERAJFORNFIL = NULL;
               SET @V_IDCONSPERPIAJPR = 'N';
               SELECT
                  @V_VRPERAJFORNFIL = MAX(VRPERAJFORNFIL),
                  @V_IDCONSPERPIAJPR = MAX(IDCONSPERPIAJPR)
               FROM AJUSTEPRFORNFIL
               WHERE AJUSTEPRFORNFIL.CDFORNECED = @V_OPLOG_CDFORNECED
                 AND AJUSTEPRFORNFIL.CDFILIAL = @V_OPLOG_CDFILIOPELOG
                 AND AJUSTEPRFORNFIL.DTINIAJPRFORFIL = (SELECT MAX(A.DTINIAJPRFORFIL)
                                                        FROM AJUSTEPRFORNFIL A
                                                        WHERE A.CDFORNECED = @V_OPLOG_CDFORNECED
                                                          AND A.CDFILIAL = @V_OPLOG_CDFILIOPELOG
                                                          AND CONVERT(DATETIME, CONVERT(VARCHAR, GETDATE(), 103), 103)
                                                              BETWEEN A.DTINIAJPRFORFIL AND ISNULL(A.DTFINAJPRFORFIL, CONVERT(DATETIME, CONVERT(VARCHAR, GETDATE(), 103), 103)));

               SET @V_PIDSV = NULL;
               IF @V_IDCONSPERPIAJPR = 'S' BEGIN
                  SELECT
                     @V_PIDSV = MAX(VRPERPIPRFO)
                  FROM PRODFORNCOMP
                  WHERE PRODFORNCOMP.CDFORNECED  = @V_OPLOG_CDFORNECED
                    AND PRODFORNCOMP.CDPRODCOMPL = @V_ITOPLOG_CDPRODUTO;

                  IF @V_PIDSV IS NULL BEGIN
                     SELECT @V_PIDSV = MAX(VRPERPIFORN)
                     FROM FORNECEDOR
                     WHERE FORNECEDOR.CDFORNECED = @V_OPLOG_CDFORNECED;
                  END;
               END;

               IF @V_PIDSV IS NULL BEGIN
                  SET @V_PIDSV = 0;
               END;
               IF @V_VRPERAJFORNFIL IS NULL BEGIN
                  SET @V_VRPERAJFORNFIL = 0;
               END;

               SET @V_ITOPLOG_VRPREUNIAF = @V_ITOPLOG_VRPREUNIAF - (@V_ITOPLOG_VRPREUNIAF * @V_PIDSV/100) + (@V_ITOPLOG_VRPREUNIAF * @V_VRPERAJFORNFIL/100);

               INSERT INTO ITEMAUTF
                (CDFILDEST,  CDFILLANC,   NRAUTOFORN,  CDMARCA,
                 CDPRODUTO,  DTPROGENTAF, CDSEGMARCA,  VRPREUNIAF,
                 VRPERDESAF, TXOBSITMAF,  VRDESCITMAF, QTPROGENTAF, IDTPLANITEAF, CDFILCOTITAF,
                 NRCOTPREITAF, CDMARCOTITAF, CDREGCOTITAF, CDFORCOTITAF,
                 CDPROCOTITAF, NRLISTAITAF)
               VALUES
                (@V_OPLOG_CDFILIOPELOG, @P_CDFILLANC, @V_NOVOCODIGO, @V_ITOPLOG_CDMARCA,
                 @V_ITOPLOG_CDPRODUTO,  @V_ITOPLOG_DTPROGENTAF, @V_ITOPLOG_CDSEGMARCA,  @V_ITOPLOG_VRPREUNIAF,
                 @V_ITOPLOG_VRPERDESAF, @V_ITOPLOG_TXOBSITMAF,  @V_ITOPLOG_VRDESCITMAF, @V_QTPROGENTAF, 'A',
                 @V_AUTOFORN_CDCENTITMAP, @V_AUTOFORN_NRCOLEITMAP, @V_AUTOFORN_CDMARCA, @V_AUTOFORN_CDREGITMAP,
                @V_AUTOFORN_CDFORNECED, @V_AUTOFORN_CDPRODUTO, @V_AUTOFORN_NRLISTAITMAP);
             END
             ELSE BEGIN
               UPDATE ITEMAUTF
               SET QTPROGENTAF = QTPROGENTAF + @V_QTPROGENTAF
               WHERE
                 CDFILDEST   = @V_OPLOG_CDFILIOPELOG  AND
                 CDFILLANC   = @P_CDFILLANC           AND
                 NRAUTOFORN  = @V_NOVOCODIGO          AND
                 CDPRODUTO   = @V_ITOPLOG_CDPRODUTO   AND
                 CDMARCA     = @V_ITOPLOG_CDMARCA     AND
                 DTPROGENTAF = @V_ITOPLOG_DTPROGENTAF;
             END;
          END;
          FETCH NEXT FROM C_ITOPLOG INTO @V_ITOPLOG_CDMARCA,
                                         @V_ITOPLOG_CDPRODUTO,
                                         @V_ITOPLOG_DTPROGENTAF,
                                         @V_ITOPLOG_CDSEGMARCA,
                                         @V_ITOPLOG_VRPREUNIAF,
                                         @V_ITOPLOG_VRPERDESAF,
                                         @V_ITOPLOG_TXOBSITMAF,
                                         @V_ITOPLOG_VRDESCITMAF,
                                         @V_ITOPLOG_QTPROGENTAF;
        END;
        CLOSE C_ITOPLOG;
        DEALLOCATE C_ITOPLOG;
        SET @V_ITEMAUTF_ANTERIOR = @V_OPLOG_CDFILDEST+@V_OPLOG_NRAUTOFORN;
        FETCH NEXT FROM C_OPLOG INTO @V_OPLOG_CDFILIOPELOG,
                                     @V_OPLOG_CDFORNECED,
                                     @V_OPLOG_CDEMPRESA,
                                     @V_OPLOG_IDTPFORPGTAF,
                                     @V_OPLOG_CDTIPCOB,
                                     @V_OPLOG_IDTIPOFRETAF,
                                     @V_OPLOG_CDFORMPGTO,
                                     @V_OPLOG_NRPARCPGTOAF,
                                     @V_OPLOG_NRDIAPGFIXAF,
                                     @V_OPLOG_IDUTDIAPGTAF,
                                     @V_OPLOG_IDTIPOEMITAF,
                                     @V_OPLOG_IDAFPRODWEB,
                                     @V_OPLOG_NRDIASPGTOAF,
                                     @V_OPLOG_VRPERCPGTOAF,
                                     @V_OPLOG_NRSEQAPURAF,
                                     @V_OPLOG_CDFILDEST,
                                     @V_OPLOG_NRAUTOFORN;
      END;
      CLOSE C_OPLOG;
      DEALLOCATE C_OPLOG;

      /*   LTIMO REGISTRO DE AF*/
      -- GERA-PARCELAS
      SET @V_NRPARCITMAF = '00';
      DECLARE C_NRPARCITMAF CURSOR FOR
       SELECT DISTINCT ITEMAUTF.DTPROGENTAF
        FROM ITEMAUTF
       WHERE (ITEMAUTF.CDFILDEST  = @V_ANTCDFILDEST) AND
             (ITEMAUTF.CDFILLANC  = @V_ANTCDFILLANC) AND
             (ITEMAUTF.NRAUTOFORN = @V_ANTCODIGO)
        ORDER BY DTPROGENTAF
      OPEN C_NRPARCITMAF;
      FETCH NEXT FROM C_NRPARCITMAF INTO @V_DTPROGENTAF1
      WHILE (@@FETCH_STATUS = 0) BEGIN
         SET @V_NRPARCITMAF = RIGHT(REPLICATE('0', 2) + CONVERT(VARCHAR, CONVERT(DOUBLE PRECISION, @V_NRPARCITMAF) + 1), 2);
         UPDATE ITEMAUTF
         SET ITEMAUTF.NRPARCITMAF = @V_NRPARCITMAF
         WHERE
            (ITEMAUTF.CDFILDEST    = @V_ANTCDFILDEST) AND
            (ITEMAUTF.CDFILLANC    = @V_ANTCDFILLANC) AND
            (ITEMAUTF.NRAUTOFORN   = @V_ANTCODIGO)   AND
            (ITEMAUTF.DTPROGENTAF  = @V_DTPROGENTAF1);
         FETCH NEXT FROM C_NRPARCITMAF INTO @V_DTPROGENTAF1
      END;
      CLOSE C_NRPARCITMAF;
      DEALLOCATE C_NRPARCITMAF;

      SET @V_CDINSCESTA = NULL;
      SELECT @V_CDINSCESTA = MIN(CDINSCESTA)
      FROM INSCRESTAD
      WHERE (CDEMPRESA = @V_ANTCDEMPRESA);
      SET @V_DTPROGENTAF = NULL;
      SELECT @V_DTPROGENTAF = MIN(DTPROGENTAF)
      FROM ITEMAUTF
      WHERE (CDFILDEST  = @V_ANTCDFILDEST)  AND
            (CDFILLANC  = @V_ANTCDFILLANC)  AND
            (NRAUTOFORN = @V_ANTCODIGO);
      EXEC IMPOSTO_ITEMAF @V_ANTCDEMPRESA,
                          @V_CDINSCESTA,
                          @V_ANTCDFORNECED,
                          @V_ANTCDFILDEST,
                          @P_CDFILLANC,
                          @V_ANTCODIGO,
                          @V_DTPROGENTAF;
      -- qryValor_AF
      SET @V_VRPRODUTO  = NULL;
      SET @V_VRDESCONTO = NULL;
      SELECT
         @V_VRPRODUTO  = SUM(ITEMAUTF.QTPROGENTAF * ITEMAUTF.VRPREUNIAF),
         @V_VRDESCONTO = SUM((ITEMAUTF.QTPROGENTAF * ITEMAUTF.VRPREUNIAF * ISNULL(ITEMAUTF.VRPERDESAF, 0)) / 100)
      FROM
         ITEMAUTF
      WHERE
         (ITEMAUTF.CDFILDEST  = @V_ANTCDFILDEST) AND
         (ITEMAUTF.CDFILLANC  = @V_ANTCDFILLANC) AND
         (ITEMAUTF.NRAUTOFORN = @V_ANTCODIGO);
      SET @V_VRIMPOSTO = 0;
      SELECT
         @V_VRIMPOSTO = ISNULL(SUM(IMPITMAF.VRADIMPAF), 0)
      FROM
         IMPITMAF,
         ITEMAUTF,
         IMPOSTO
      WHERE
         (IMPITMAF.CDFILDEST   = @V_ANTCDFILDEST)       AND
         (IMPITMAF.CDFILLANC   = @V_ANTCDFILLANC)       AND
         (IMPITMAF.NRAUTOFORN  = @V_ANTCODIGO)          AND
         (IMPITMAF.CDFILDEST   = ITEMAUTF.CDFILDEST)    AND
         (IMPITMAF.CDFILLANC   = ITEMAUTF.CDFILLANC)    AND
         (IMPITMAF.NRAUTOFORN  = ITEMAUTF.NRAUTOFORN)   AND
         (IMPITMAF.CDPRODUTO   = ITEMAUTF.CDPRODUTO)    AND
         (IMPITMAF.CDMARCA     = ITEMAUTF.CDMARCA)      AND
         (IMPITMAF.DTPROGENTAF = ITEMAUTF.DTPROGENTAF)  AND
         (IMPITMAF.CDIMPOSTO   = IMPOSTO.CDIMPOSTO)     AND
          ISNULL(IMPOSTO.IDACRPRODENTRNF, 'N') = 'N';
          
      UPDATE AUTOFORNE
      SET VRTOTALAF = @V_VRPRODUTO - @V_VRDESCONTO + @V_VRIMPOSTO
      WHERE
         (CDFILDEST   = @V_ANTCDFILDEST) AND
         (CDFILLANC   = @V_ANTCDFILLANC) AND
         (NRAUTOFORN  = @V_ANTCODIGO);
   END;
   
   UPDATE APURPRECO
   SET CDCOMPRADOR = @P_CDOPERADOR
   WHERE APURPRECO.CDFILCENTCMP = @P_CDCENTCMP
     AND APURPRECO.NRAPURPREC   = @P_NRSEQAPUR
     AND CDCOMPRADOR IS NULL;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'EFETIVAR_AF','6.25.xxx';
GO

